/** 
*/

#ifndef CCOMPONENT_H
#define CCOMPONENT_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class CComponentData;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class CComponent : public IComponent,
IExtendPropertySheet2, 
IExtendControlbar
{
public:
    // LIFECYCLE

     CComponent(CComponentData *parent);
     ~CComponent();
        
    // OPERATORS
    // OPERATIONS

    ///////////////////////////////
    // Interface IUnknown
    ///////////////////////////////
    STDMETHODIMP QueryInterface(REFIID riid, LPVOID *ppv);
    STDMETHODIMP_(ULONG) AddRef();
    STDMETHODIMP_(ULONG) Release();

    ///////////////////////////////
    // Interface IComponent
    ///////////////////////////////
    virtual HRESULT STDMETHODCALLTYPE Initialize( 
    /* [in] */ LPCONSOLE lpConsole);
            
    virtual HRESULT STDMETHODCALLTYPE Notify( 
    /* [in] */ LPDATAOBJECT lpDataObject,
    /* [in] */ MMC_NOTIFY_TYPE event,
    /* [in] */ LPARAM arg,
    /* [in] */ LPARAM param);
            
    virtual HRESULT STDMETHODCALLTYPE Destroy( 
    /* [in] */ MMC_COOKIE cookie);
            
    virtual HRESULT STDMETHODCALLTYPE QueryDataObject( 
    /* [in] */ MMC_COOKIE cookie,
    /* [in] */ DATA_OBJECT_TYPES type,
    /* [out] */ LPDATAOBJECT __RPC_FAR *ppDataObject);
            
    virtual HRESULT STDMETHODCALLTYPE GetResultViewType( 
    /* [in] */ MMC_COOKIE cookie,
    /* [out] */ LPOLESTR __RPC_FAR *ppViewType,
    /* [out] */ long __RPC_FAR *pViewOptions);
            
    virtual HRESULT STDMETHODCALLTYPE GetDisplayInfo( 
    /* [out][in] */ RESULTDATAITEM __RPC_FAR *pResultDataItem);
            
    virtual HRESULT STDMETHODCALLTYPE CompareObjects( 
    /* [in] */ LPDATAOBJECT lpDataObjectA,
    /* [in] */ LPDATAOBJECT lpDataObjectB);
    
    ///////////////////////////////
    // Interface IExtendControlBar
    ///////////////////////////////
    virtual /* [helpstring] */ HRESULT STDMETHODCALLTYPE SetControlbar( 
    /* [in] */ LPCONTROLBAR pControlbar);

    virtual /* [helpstring] */ HRESULT STDMETHODCALLTYPE ControlbarNotify( 
    /* [in] */ MMC_NOTIFY_TYPE event,
    /* [in] */ LPARAM arg,
    /* [in] */ LPARAM param);
    
    
    //////////////////////////////////
    // Interface IExtendPropertySheet2
    //////////////////////////////////
            
    virtual HRESULT STDMETHODCALLTYPE CreatePropertyPages( 
    /* [in] */ LPPROPERTYSHEETCALLBACK lpProvider,
    /* [in] */ LONG_PTR handle,
    /* [in] */ LPDATAOBJECT lpIDataObject);
            
    virtual HRESULT STDMETHODCALLTYPE QueryPagesFor( 
    /* [in] */ LPDATAOBJECT lpDataObject);
            
    virtual HRESULT STDMETHODCALLTYPE GetWatermarks( 
    /* [in] */ LPDATAOBJECT lpIDataObject,
    /* [out] */ HBITMAP __RPC_FAR *lphWatermark,
    /* [out] */ HBITMAP __RPC_FAR *lphHeader,
    /* [out] */ HPALETTE __RPC_FAR *lphPalette,
    /* [out] */ BOOL __RPC_FAR *bStretch);

    // CALLBACK
    // ACCESS

    IConsole* GetConsole()
    {
        return m_ipConsole;
    }

    IToolbar *GetToolbar() 
    { 
        return m_ipToolbar; 
    }

    // INQUIRY
    
protected:
private:
    ULONG m_cref;
    IConsole *m_ipConsole;
    IControlbar *m_ipControlBar;
    IToolbar *m_ipToolbar;
    class CComponentData *m_pComponentData;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* CCOMPONENT_H_ */

