// DlgOption.cpp : implementation file
//

#include "stdafx.h"
#include "warmmcsnapin.h"
#include "DlgOption.h"
#include "PropPageOptions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgOption dialog


CDlgOption::CDlgOption(WmsOption *pOption,
                       CWnd* pParent /*=NULL*/)
	: CDialog(CDlgOption::IDD, pParent),
    mpOption(pOption)
{
	//{{AFX_DATA_INIT(CDlgOption)
	m_bUseDefault = (pOption->mHaveValue == false);
	m_Value = pOption->mCurrentValue;
	m_Name = WarCollector<TCHAR>(pOption->mName).GetValue().c_str();
	m_Description = WarCollector<TCHAR>(pOption->mDescription).GetValue().c_str();
	//}}AFX_DATA_INIT
}


void CDlgOption::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOption)
	DDX_Control(pDX, IDC_VALUE, m_ctlValue);
	DDX_Check(pDX, IDC_USE_DEFAULT, m_bUseDefault);
	DDX_Text(pDX, IDC_VALUE, m_Value);
	DDX_Text(pDX, IDC_OPT_NAME, m_Name);
	DDX_Text(pDX, IDC_EDIT1, m_Description);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgOption, CDialog)
	//{{AFX_MSG_MAP(CDlgOption)
	ON_BN_CLICKED(IDC_USE_DEFAULT, OnUseDefault)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOption message handlers

BOOL CDlgOption::OnInitDialog() 
{
	CDialog::OnInitDialog();

    EnableDisableControls();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgOption::OnOK() 
{
	UpdateData();

    mpOption->mHaveValue = (m_bUseDefault == false);
    if (m_bUseDefault)
        mpOption->mCurrentValue = WarCollector<TCHAR>(mpOption->mDefaultValue).GetValue().c_str();
    else
        mpOption->mCurrentValue = m_Value;
	
	CDialog::OnOK();
}

void CDlgOption::OnUseDefault() 
{
	EnableDisableControls();
}

void CDlgOption::EnableDisableControls()
{
    UpdateData();
    
    m_ctlValue.EnableWindow(m_bUseDefault == false);
}
