// PropPageAuthModuleGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "warmmcsnapin.h"
#include "PropPageAuthModuleGeneral.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropPageAuthModuleGeneral property page

IMPLEMENT_DYNCREATE(CPropPageAuthModuleGeneral, CPropertyPage)

CPropPageAuthModuleGeneral::CPropPageAuthModuleGeneral(war_if_aut_module_ptr_t& authPtr) 
: CPropertyPage(CPropPageAuthModuleGeneral::IDD),
mAuthPtr(authPtr)
{
	//{{AFX_DATA_INIT(CPropPageAuthModuleGeneral)
	m_bEnable = mAuthPtr->IsEnabled();
	m_bAllowAnon = mAuthPtr->GetAuth().IsAnonAllowed();
	//}}AFX_DATA_INIT
}

CPropPageAuthModuleGeneral::~CPropPageAuthModuleGeneral()
{
}

void CPropPageAuthModuleGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropPageAuthModuleGeneral)
	DDX_Check(pDX, IDC_ENABLE, m_bEnable);
	DDX_Check(pDX, IDC_ALLOW_ANON, m_bAllowAnon);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropPageAuthModuleGeneral, CPropertyPage)
	//{{AFX_MSG_MAP(CPropPageAuthModuleGeneral)
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_BN_CLICKED(IDC_ALLOW_ANON, OnChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropPageAuthModuleGeneral message handlers

BOOL CPropPageAuthModuleGeneral::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
    if (!mAuthPtr->GetAuth().IsAnonSupported())
        GetDlgItem(IDC_ALLOW_ANON)->ShowWindow(SW_HIDE);

    DoSetStates();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CPropPageAuthModuleGeneral::OnApply() 
{
    if (mAuthPtr->GetAuth().IsAnonSupported())
	    mAuthPtr->GetAuth().SetEnableAnon(m_bAllowAnon);
    
    mAuthPtr->SetEnable(m_bEnable);
	
	return CPropertyPage::OnApply();
}

void CPropPageAuthModuleGeneral::DoSetStates()
{
    GetDlgItem(IDC_ALLOW_ANON)->EnableWindow(m_bEnable);
}

void CPropPageAuthModuleGeneral::OnEnable() 
{
    UpdateData();
	SetModified();
    DoSetStates();
}

void CPropPageAuthModuleGeneral::OnChange() 
{
    SetModified();
}
