// PropPageLogModule.cpp : implementation file
//

#include "stdafx.h"
#include "warmmcsnapin.h"
#include "PropPageLogModule.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropPageLogModule property page

IMPLEMENT_DYNCREATE(CPropPageLogModule, CPropertyPage)

CPropPageLogModule::CPropPageLogModule(war_if_log_module_ptr_t& logModulePtr) : 
CPropertyPage(CPropPageLogModule::IDD),
mLogModulePtr(logModulePtr)
{
    CString my_events = mLogModulePtr->GetEvents().c_str();

	//{{AFX_DATA_INIT(CPropPageLogModule)
	m_bEnable = mLogModulePtr->IsEnabled();
	m_bSystem = my_events.Find(_T("WARLOG_SYSTEM")) != -1;
	m_bError = my_events.Find(_T("WARLOG_ERROR")) != -1;
	m_bWarning = my_events.Find(_T("WARLOG_WARNINGS")) != -1;
	m_bSecurity = my_events.Find(_T("WARLOG_SECURITY")) != -1;
	m_bInformative = my_events.Find(_T("WARLOG_INFO")) != -1;
	m_bLogin = my_events.Find(_T("WARLOG_LOGIN")) != -1;
	m_bLogout = my_events.Find(_T("WARLOG_LOGOUT")) != -1;
	m_bAudit = my_events.Find(_T("WARLOG_INOUT")) != -1;
	m_Upload = my_events.Find(_T("WARLOG_RCVFILE")) != -1;
	m_bDownload = my_events.Find(_T("WARLOG_SNDFILE")) != -1;
	m_bDeleteFile = my_events.Find(_T("WARLOG_DELFILE")) != -1;
	m_bCreateDir = my_events.Find(_T("WARLOG_CREDIR")) != -1;
	m_bDeleteDir = my_events.Find(_T("WARLOG_DELDIR")) != -1;
	m_bUserCreated = my_events.Find(_T("WARLOG_CREACC")) != -1;
	m_bUserDeleted = my_events.Find(_T("WARLOG_DELACC")) != -1;
	m_bUserChanged = my_events.Find(_T("WARLOG_CHGACC")) != -1;
	m_bNetwork = my_events.Find(_T("WARLOG_NETWORK")) != -1;
	m_bDbDebug = my_events.Find(_T("WARLOG_DEBUG")) != -1;
	m_bDbNetwork = my_events.Find(_T("WARLOG_SOCKET")) != -1;
	m_bDbFiles = my_events.Find(_T("WARLOG_FILES")) != -1;
	m_bDbThreads = my_events.Find(_T("WARLOG_THREADS")) != -1;
	m_bDbCps = my_events.Find(_T("WARLOG_CPS")) != -1;
    m_FileName = _T("");
	//}}AFX_DATA_INIT

    if (mLogModulePtr->HaveFileName())
        m_FileName = mLogModulePtr->GetFileName().c_str();
    else if (mLogModulePtr->HaveTagName())
        m_FileName = mLogModulePtr->GetTagName().c_str();
}

CPropPageLogModule::~CPropPageLogModule()
{
}

void CPropPageLogModule::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropPageLogModule)
	DDX_Control(pDX, IDC_OPTIONNAME, m_ctlFileNameLabel);
	DDX_Control(pDX, IDC_FILENAME, m_ctlFileName);
	DDX_Check(pDX, IDC_ENABLE, m_bEnable);
	DDX_Check(pDX, IDC_SYSEM, m_bSystem);
	DDX_Check(pDX, IDC_ERROR, m_bError);
	DDX_Check(pDX, IDC_WARNING, m_bWarning);
	DDX_Check(pDX, IDC_SECURITY, m_bSecurity);
	DDX_Check(pDX, IDC_INFO, m_bInformative);
	DDX_Check(pDX, IDC_LOGIN, m_bLogin);
	DDX_Check(pDX, IDC_LOGOUT, m_bLogout);
	DDX_Check(pDX, IDC_AUDIT, m_bAudit);
	DDX_Check(pDX, IDC_UPLOAD, m_Upload);
	DDX_Check(pDX, IDC_DOWNLOAD, m_bDownload);
	DDX_Check(pDX, IDC_DELETEFILE, m_bDeleteFile);
	DDX_Check(pDX, IDC_CREATEDIR, m_bCreateDir);
	DDX_Check(pDX, IDC_DELETEDIR, m_bDeleteDir);
	DDX_Check(pDX, IDC_USERCREATED, m_bUserCreated);
	DDX_Check(pDX, IDC_USERDELETED, m_bUserDeleted);
	DDX_Check(pDX, IDC_USERCHANGED, m_bUserChanged);
	DDX_Check(pDX, IDC_NETWORK, m_bNetwork);
	DDX_Check(pDX, IDC_DBDEBUG, m_bDbDebug);
	DDX_Check(pDX, IDC_DBNETWORK, m_bDbNetwork);
	DDX_Check(pDX, IDC_DBFILES, m_bDbFiles);
	DDX_Check(pDX, IDC_DBTHREADS, m_bDbThreads);
	DDX_Check(pDX, IDC_DBCPS, m_bDbCps);
	DDX_Text(pDX, IDC_OPTIONNAME, m_FileNameLabel);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	//}}AFX_DATA_MAP

    DoSetStates();
}


BEGIN_MESSAGE_MAP(CPropPageLogModule, CPropertyPage)
	//{{AFX_MSG_MAP(CPropPageLogModule)
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_BN_CLICKED(IDC_SYSEM, OnChange)
	ON_BN_CLICKED(IDC_ERROR, OnChange)
	ON_BN_CLICKED(IDC_WARNING, OnChange)
	ON_BN_CLICKED(IDC_INFO, OnChange)
	ON_BN_CLICKED(IDC_LOGIN, OnChange)
	ON_BN_CLICKED(IDC_LOGOUT, OnChange)
	ON_BN_CLICKED(IDC_AUDIT, OnChange)
	ON_BN_CLICKED(IDC_UPLOAD, OnChange)
	ON_BN_CLICKED(IDC_DOWNLOAD, OnChange)
	ON_BN_CLICKED(IDC_DELETEFILE, OnChange)
	ON_BN_CLICKED(IDC_CREATEDIR, OnChange)
	ON_BN_CLICKED(IDC_DELETEDIR, OnChange)
	ON_BN_CLICKED(IDC_USERCREATED, OnChange)
	ON_BN_CLICKED(IDC_USERDELETED, OnChange)
	ON_BN_CLICKED(IDC_USERCHANGED, OnChange)
	ON_BN_CLICKED(IDC_NETWORK, OnChange)
	ON_BN_CLICKED(IDC_DBDEBUG, OnChange)
	ON_BN_CLICKED(IDC_DBNETWORK, OnChange)
	ON_BN_CLICKED(IDC_DBFILES, OnChange)
	ON_BN_CLICKED(IDC_DBTHREADS, OnChange)
	ON_BN_CLICKED(IDC_DBCPS, OnChange)
	ON_EN_CHANGE(IDC_FILENAME, OnChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropPageLogModule message handlers

BOOL CPropPageLogModule::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

    if (mLogModulePtr->HaveFileName())
    {
        CString my_label;
        my_label.LoadString(IDS_FILENAMELABEL);
        m_ctlFileName.ShowWindow(SW_SHOW);
        m_ctlFileNameLabel.SetWindowText(my_label);
        m_ctlFileNameLabel.ShowWindow(SW_SHOW);
    }
    else if (mLogModulePtr->HaveTagName())
    {
        CString my_label;
        my_label.LoadString(IDS_TAGNAMELABEL);
        m_ctlFileName.ShowWindow(SW_SHOW);
        m_ctlFileNameLabel.SetWindowText(my_label);
        m_ctlFileNameLabel.ShowWindow(SW_SHOW);
    }
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPropPageLogModule::OnEnable() 
{
    UpdateData();
    OnChange();
    
    DoSetStates();
}

void CPropPageLogModule::DoSetStates()
{
    for(int i = IDC_SYSEM; i <= IDC_FILENAME; i++)
    {
        CWnd *pwnd = GetDlgItem(i);
        if (pwnd)
            pwnd->EnableWindow(m_bEnable);
    }
}


BOOL CPropPageLogModule::OnApply() 
{
    // Save
    UpdateData(FALSE);

    CString my_events;

    mLogModulePtr->SetEnable(m_bEnable);
        
	if (m_bSystem) my_events += _T("WARLOG_SYSTEM;");
	if (m_bError) my_events += _T("WARLOG_ERROR;");
	if (m_bWarning) my_events += _T("WARLOG_WARNINGS;");
	if (m_bSecurity) my_events += _T("WARLOG_SECURITY;");
	if (m_bInformative) my_events += _T("WARLOG_INFO;");
	if (m_bLogin) my_events += _T("WARLOG_LOGIN;");
	if (m_bLogout) my_events += _T("WARLOG_LOGOUT;");
	if (m_bAudit) my_events += _T("WARLOG_INOUT;");
	if (m_Upload) my_events += _T("WARLOG_RCVFILE;");
	if (m_bDownload) my_events += _T("WARLOG_SNDFILE;");
	if (m_bDeleteFile) my_events += _T("WARLOG_DELFILE;");
	if (m_bCreateDir) my_events += _T("WARLOG_CREDIR;");
	if (m_bDeleteDir) my_events += _T("WARLOG_DELDIR;");
	if (m_bUserCreated) my_events += _T("WARLOG_CREACC;");
	if (m_bUserDeleted) my_events += _T("WARLOG_DELACC;");
	if (m_bUserChanged) my_events += _T("WARLOG_CHGACC;");
	if (m_bNetwork) my_events += _T("WARLOG_NETWORK;");
	if (m_bDbDebug) my_events += _T("WARLOG_DEBUG;");
	if (m_bDbNetwork) my_events += _T("WARLOG_SOCKET;");
	if (m_bDbFiles) my_events += _T("WARLOG_FILES;");
	if (m_bDbThreads) my_events += _T("WARLOG_THREADS;");
	if (m_bDbCps) my_events += _T("WARLOG_CPS;");

    mLogModulePtr->SetEvents(war_regstr_t(my_events.IsEmpty() ? _T("") : my_events));

    if (mLogModulePtr->HaveFileName())
        mLogModulePtr->SetFileName(war_regstr_t(m_FileName.IsEmpty() ? _T("") : m_FileName));
    else if (mLogModulePtr->HaveTagName())
        mLogModulePtr->SetTagName(war_regstr_t(m_FileName.IsEmpty() ? _T("") : m_FileName));

	return CPropertyPage::OnApply();
}

void CPropPageLogModule::OnChange() 
{
	SetModified();
}
