#if !defined(AFX_PROPPAGESHAREPERMS_H__5808279E_A9DF_4FEC_8683_F64B1C2A76ED__INCLUDED_)
#define AFX_PROPPAGESHAREPERMS_H__5808279E_A9DF_4FEC_8683_F64B1C2A76ED__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PropPageSharePerms.h : header file
//

#include "WarIfUser.h"
#include "WarIfSite.h"
#include "WarMmcFileTypes.h"
#include "WarSvrPath.h"
#include "WarAutoCounter.h"

class WmsMergedPerms
{
public:
    enum PermStateE
    {
        STATE_ON = BST_CHECKED,
        STATE_OFF = BST_UNCHECKED,
        STATE_CRASH = BST_INDETERMINATE
    };

    WmsMergedPerms()
    {
        memset(&mPerms, STATE_OFF, sizeof(mPerms));
        mSymlink = 0;
    }

    // Bits
    PermStateE mPerms[32];
    int mSymlink; // -1 = crash, 0, 1,2,3 are valid
};


/////////////////////////////////////////////////////////////////////////////
// CPropPageSharePerms dialog

class CPropPageSharePerms : 
public CPropertyPage,
public WarSvrEnums
{
// Construction
public:
    typedef std::set<WarSvrPath> svrpath_set_t;

    CPropPageSharePerms() {};   // standard constructor
	CPropPageSharePerms(war_if_user_ptr_t& rUserPtr);   // standard constructor
    CPropPageSharePerms(war_if_site_ptr_t& rSitePtr);   // standard constructor
    ~CPropPageSharePerms();

// Dialog Data
	//{{AFX_DATA(CPropPageSharePerms)
	enum { IDD = IDD_PP_SHARE };
	CComboBox	m_ctlStyleList;
	CComboBox	m_ctlSymlinksList;
	CListCtrl	m_ctlShares;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPropPageSharePerms)
    public:
    virtual BOOL OnApply();
    virtual BOOL OnSetActive();
    virtual BOOL OnWizardFinish();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPropPageSharePerms)
	afx_msg void OnItemchangingShares(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangedShares(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnAppend();
	afx_msg void OnCreate();
	afx_msg void OnCwd();
	afx_msg void OnDelete();
	afx_msg void OnDeny();
	afx_msg void OnExecute();
	afx_msg void OnFree();
	afx_msg void OnHide();
	afx_msg void OnList();
	afx_msg void OnMapSymlinks();
	afx_msg void OnMkSymlinks();
	afx_msg void OnRead();
	afx_msg void OnRecursive();
	afx_msg void OnRemove();
	afx_msg void OnSharedUpload();
	afx_msg void OnRclickShares(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkShares(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeStyle();
	virtual BOOL OnInitDialog();
	afx_msg void OnWrite();
	afx_msg void OnSelchangeSymlinks();
	afx_msg void OnDeleteitemShares(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnNewShare();
	afx_msg void OnPropertiesShare();
	afx_msg void OnDeleteShare();
	//}}AFX_MSG

    void OnDropFiles(HDROP dropInfo);

	DECLARE_MESSAGE_MAP()

private:
    war_if_user_ptr_t mUserPtr;
    war_if_site_ptr_t mSitePtr;
    WarMmcFileTypes mStyles;
    WarWin32Registry mRegKey;
    CImageList mImageList;
    bool mIsInitialized;
    int mLockedCnt;

    void UpdatePermsOnScreen(bool doFullUpdate = false);
    void RefreshShareList();
    void InsertPathToList(const WarSvrPath& newPath);
    void GetPermsFromList(WmsMergedPerms& resultPerms, war_uint32_t& nativePerms);
    void SetPermsOnScreen();
    void OnChangeCheckbox(int dlgId, int bit);
    void EnableDisableControls(war_uint32_t perms, bool canEnable);
    int GetPermIndex(int bit);
    void EditShare(WarSvrPath *pPath, int itemIndex);
    int GetIconIndex(const WarSvrPath& svrPath);
    void SetIconsOnScreen();
    CString ExpandShortcut(CString& csFilename) const;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PROPPAGESHAREPERMS_H__5808279E_A9DF_4FEC_8683_F64B1C2A76ED__INCLUDED_)
