// PropPageSiteGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "warmmcsnapin.h"
#include "PropPageSiteGeneral.h"
#include "PropPageProtocolFtp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPropPageSiteGeneral property page

IMPLEMENT_DYNCREATE(CPropPageSiteGeneral, CPropertyPage)

CPropPageSiteGeneral::CPropPageSiteGeneral(war_if_site_ptr_t& rSitePtr) 
: CPropertyPage(CPropPageSiteGeneral::IDD),
mSitePtr(rSitePtr)
{
	//{{AFX_DATA_INIT(CPropPageSiteGeneral)
	m_bEnable = mSitePtr->IsEnabled();
	m_SiteName = mSitePtr->GetSiteName().c_str();
	//}}AFX_DATA_INIT
}

CPropPageSiteGeneral::~CPropPageSiteGeneral()
{
}

void CPropPageSiteGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPropPageSiteGeneral)
	DDX_Check(pDX, IDC_ENABLE, m_bEnable);
	DDX_Text(pDX, IDC_NAME, m_SiteName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPropPageSiteGeneral, CPropertyPage)
	//{{AFX_MSG_MAP(CPropPageSiteGeneral)
	ON_BN_CLICKED(IDC_PROTOCOLS, OnProtocols)
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_EN_CHANGE(IDC_NAME, OnChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPropPageSiteGeneral message handlers

BOOL CPropPageSiteGeneral::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

    DoSetStates();
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPropPageSiteGeneral::DoSetStates()
{
    UpdateData();
    
    GetDlgItem(IDC_NAME)->EnableWindow(m_bEnable);
    GetDlgItem(IDC_PROTOCOLS)->EnableWindow(m_bEnable);
}


BOOL CPropPageSiteGeneral::OnApply() 
{
    UpdateData();

    mSitePtr->SetEnable(m_bEnable);
    mSitePtr->SetSiteName(m_SiteName);

	return CPropertyPage::OnApply();
}


void CPropPageSiteGeneral::OnProtocols() 
{
    CPropertySheet sheet;
    CPropPageProtocolFtp pp_ftp(mSitePtr);

    sheet.AddPage(&pp_ftp);
    sheet.DoModal();
}

void CPropPageSiteGeneral::OnEnable() 
{
    OnChange();
    DoSetStates();
}

void CPropPageSiteGeneral::OnChange() 
{
    SetModified();
}
