/** 
*/

#ifndef STATIC_NODE_H
#define STATIC_NODE_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef CDELEGATION_BASE_H
#   include "DelegationBase.h"
#endif

#ifndef WAR_IF_ROOT_H
#   include "WarIfRoot.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class CStaticNode : public CDelegationBase
{
public:
    // LIFECYCLE

    CStaticNode();
    virtual ~CStaticNode();

    // OPERATORS
    // OPERATIONS

    virtual const _TCHAR *GetDisplayName(int nCol = 0);
    virtual const GUID & getNodeType();
    virtual const int GetBitmapIndex();

    virtual HRESULT CreatePropertyPages(IPropertySheetCallback *lpProvider, LONG_PTR handle);
    virtual HRESULT HasPropertySheets();
    virtual HRESULT GetWatermarks(HBITMAP *lphWatermark,
        HBITMAP *lphHeader,
        HPALETTE *lphPalette,
        BOOL *bStretch);

    LONG getDataSize() { return sizeof(privateData); }
    void *getData() { return &snapInData; }
    bool isDirty() { return snapInData.m_isDirty; }
    void clearDirty() { snapInData.m_isDirty = false; };
        
    _TCHAR *getHost() { return *snapInData.m_host == 0 ? NULL : snapInData.m_host; }

    bool Initialize();

    // CALLBACK

    virtual HRESULT OnExpand(
        IConsoleNameSpace *pConsoleNameSpace, 
        IConsole *pConsole, HSCOPEITEM parent);

    // ACCESS
    // INQUIRY
    
protected:
private:
    static const GUID thisGuid;
    war_if_root_ptr_t mWarRootPtr;
    bool mIsInitialized;

    struct privateData {
        _TCHAR m_host[MAX_PATH];
        BOOL m_fIsRadioLocalMachine;
        BOOL m_fAllowOverrideMachineNameOut;
        bool m_isDirty;
        
        privateData() : m_isDirty(false) {
            ZeroMemory(m_host, sizeof(m_host));
            m_fIsRadioLocalMachine = TRUE;
            m_fAllowOverrideMachineNameOut = FALSE;
        }
    } snapInData;

    static BOOL CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* STATIC_NODE_H_ */

