/** 
*/

#ifndef WAR_MMC_FILE_TYPES_H
#define WAR_MMC_FILE_TYPES_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_WIN32_REGISTRY_H
#   include "WarWin32Registry.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarMmcFileTypeStyle
{
public:
    WarMmcFileTypeStyle(LPCTSTR name, war_uint32_t permissions)
        : mName(name),
        mPerms(permissions)
    {}

    WarMmcFileTypeStyle(const WarMmcFileTypeStyle& from)
    {
        operator = (from);
    }

    void operator = (const WarMmcFileTypeStyle& from)
    {
        mName = from.mName;
        mPerms = from.mPerms;
    }

    std::basic_string<TCHAR> mName;
    war_uint32_t mPerms;
};

class WarMmcFileType
{
public:
    typedef std::list<WarMmcFileTypeStyle> themes_t;

    WarMmcFileType(LPCTSTR name, bool isEnabled = true)
        : mName(name),
        mIsEnabled(isEnabled)
    {}

    WarMmcFileType(const WarMmcFileType& from)
    {
        operator = (from);
    }

    bool operator == (LPCTSTR from) const
    {
        return _tcscmp(mName.c_str(), from) == 0;
    }

    operator = (const WarMmcFileType& from)
    {
        mName = from.mName;
        mThemes = from.mThemes;
        mIsEnabled = from.mIsEnabled;
    }

    std::basic_string<TCHAR> mName;
    themes_t mThemes;
    bool mIsEnabled;
};

class WarMmcFileTypes 
{
public:
    typedef std::list<WarMmcFileType> filetypes_t;

    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarMmcFileTypes(void);
       
    /**
    * Destructor.
    */
    ~WarMmcFileTypes(void);
    
    // OPERATORS
    // OPERATIONS     
    
    void Load(const WarWin32Registry& regPath);

    const WarMmcFileType& GetTypeFromName(LPCTSTR currentName) 
        const throw(WarException);

    void UpdateComboBox(HWND hWnd, 
        LPCTSTR currentName,
        war_uint32_t currentPerms,
        bool doResetContent = false) const
        throw(WarException);
    
    // ACCESS
    // INQUIRY
    
protected:
private:
    filetypes_t mFileTypes;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_MMC_FILE_TYPES_H */

