#include "StdAfx.h"
#include "WarMmcSnapin.h"
#include "WmsNodeLogModule.h"   // class implemented
#include "WarCollector.h"
#include "WarIfLogModule.h"


/////////////////////////////// PUBLIC ///////////////////////////////////////

// {CE120B0B-60D2-4737-A0C4-DA1F5AD14BC5}
const GUID WmsNodeLogModule::thisGuid = 
{ 0xce120b0b, 0x60d2, 0x4737, { 0xa0, 0xc4, 0xda, 0x1f, 0x5a, 0xd1, 0x4b, 0xc5 } };


WmsNodeLogModule::WmsNodeLogModule(war_if_log_module_ptr_t& logModulePtr)
: mLogModulePtr(logModulePtr) // Deleted by parent
{
}

WmsNodeLogModule::~WmsNodeLogModule()
{
}

//============================= LIFECYCLE ====================================
//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= CALLBACK     ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

const int WmsNodeLogModule::GetBitmapIndex()
{
    return mLogModulePtr->IsEnabled() 
        ? NICON_LOG_MODULE_CONFIG 
        : NICON_LOG_MODULE_CONFIG_DISABLED;
}

const _TCHAR *WmsNodeLogModule::GetDisplayName(int nCol)
{
    switch(nCol)
    {
    case 0:
        return mLogModulePtr->GetName();
    case 1:
        {
            static WarCollector<TCHAR> result;
            result = _T("-");

            if (mLogModulePtr->HaveFileName())
                result = mLogModulePtr->GetFileName().c_str();
            else if (mLogModulePtr->HaveTagName())
                result = mLogModulePtr->GetTagName().c_str();

            return result.GetValue().c_str();
        }
    default:
        return _T("Invalid column index");
    }
}

const GUID & WmsNodeLogModule::getNodeType()
{
    return thisGuid; 
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

