#include "StdAfx.h"
#include "WarMmcSnapin.h"
#include "WmsNodeSecurity.h"   // class implemented
#include "WarCollector.h"
#include "WarIfServer.h"
#include "WmsNodeAuthModules.h"


/////////////////////////////// PUBLIC ///////////////////////////////////////


// {9D34C6B4-AA28-4492-B34C-C2910BFD4328}
const GUID WmsNodeSecurity::thisGuid = 
{ 0x9d34c6b4, 0xaa28, 0x4492, { 0xb3, 0x4c, 0xc2, 0x91, 0xb, 0xfd, 0x43, 0x28 } };


WmsNodeSecurity::WmsNodeSecurity(war_if_site_ptr_t& rSitePtr)
: mSitePtr(rSitePtr) // Deleted by parent
{
}

WmsNodeSecurity::~WmsNodeSecurity()
{
}

//============================= LIFECYCLE ====================================
//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= CALLBACK     ===================================

HRESULT WmsNodeSecurity::OnExpand(IConsoleNameSpace *pConsoleNameSpace, 
                                 IConsole *pConsole, 
                                 HSCOPEITEM parent)
{
    if (GetHandle() == NULL) 
        SetHandle((HANDLE)parent);

    if (!bExpanded) 
    {
        // create the child nodes, then expand them
        for(int i = 0; i < 1; i++)
        {
            CDelegationBase *pnew_node;
            SCOPEDATAITEM sdi;

            switch(i)
            {
            case 0:
                pnew_node = new WmsNodeAuthModules(mSitePtr);
                break;
            }

            ZeroMemory(&sdi, sizeof(SCOPEDATAITEM));
            sdi.mask = SDI_STR|   // Displayname is valid
                SDI_PARAM     |   // lParam is valid
                SDI_IMAGE     |   // nImage is valid
                SDI_OPENIMAGE |   // nOpenImage is valid
                SDI_PARENT    |
                SDI_CHILDREN;
            
            sdi.relativeID  = (HSCOPEITEM)parent;
            sdi.nImage      = pnew_node->GetBitmapIndex();
            sdi.nOpenImage  = pnew_node->GetBitmapIndex();
            sdi.displayname = MMC_CALLBACK;
            sdi.lParam      = (LPARAM)pnew_node;     // The cookie
            
            HRESULT hr = pConsoleNameSpace->InsertItem(&sdi);
            _ASSERT( SUCCEEDED(hr) );
            
            pnew_node->SetHandle((HANDLE)sdi.ID);
        }
    }
 
    return S_OK;   
}

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

const int WmsNodeSecurity::GetBitmapIndex()
{
    return NICON_SITE_SECURITY;
}

const _TCHAR *WmsNodeSecurity::GetDisplayName(int nCol)
{
    static _TCHAR szDisplayName[256] = {0};
    
    if (!*szDisplayName)
    {
        LoadString(g_hinst, 
            IDS_NODE_SECURITY, 
            szDisplayName, 
            sizeof(szDisplayName));
    }
    
    return szDisplayName; 
}

const GUID & WmsNodeSecurity::getNodeType()
{
    return thisGuid; 
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

