#include "StdAfx.h"
#include "WarClientSession.h"   // class implemented

using namespace std;

/////////////////////////////// PUBLIC ///////////////////////////////////////

war_uint64_t WarClientSession::sSeqCounter; 

//============================= LIFECYCLE ====================================

WarClientSession::WarClientSession(const std::string& siteName, 
        const std::string& userName,
        const WarNetAddress& fromHost,
        const war_uint64_t& fromSocketSeqId) :
    mSite(siteName), mName(userName), mRemoteHost(fromHost), 
        mSeqNumber(++sSeqCounter), mSocketSeqNumber(fromSocketSeqId)
{
}// WarClientSession


WarClientSession::~WarClientSession()
{
}// ~WarClientSession


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= CALLBACK   ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================


std::string WarClientSession::Explain() const
{
    WarCollector<char> rval;

    rval << mSeqNumber
        << '/'
        << mSite
        << "::"
        << mName
        << '/'
        << mRemoteHost.Explain()
        << '/'
        << mLoginTime.FormatLT();

    return rval.GetValue();
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

