#include "StdAfx.h"
#include "WarFileDriverFile.h"   // class implemented

#ifndef WAR_FILE_H
#   include "WarFile.h"
#endif

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarFileDriverFile::WarFileDriverFile(WarFileDriver *pDriver)
: mpDriver(pDriver),
mFlags(0)
{
}

WarFileDriverFile::~WarFileDriverFile()
{
}


//============================= OPERATORS ====================================


//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

war_flen_t WarFileDriverFile::GetPosition()
{
    return Seek(0, WAR_SEEK_CURRENT);
}

war_flen_t WarFileDriverFile::GetLength()
{
    war_flen_t Curr = Seek(0, WAR_SEEK_CURRENT);
    war_flen_t End = Seek(0, WAR_SEEK_END);
    if (Curr != End)
        Seek(Curr);
    return End;
}

bool WarFileDriverFile::IsEof()
{
    war_flen_t Curr = Seek(0, WAR_SEEK_CURRENT);
    if (Curr >= Seek(0, WAR_SEEK_END))
        return true;
    Seek(Curr);
    return false;
}

bool WarFileDriverFile::IsOpen()
{
    WarThrow(WarError(WAR_ERR_NOT_IMPLEMENTED), NULL);
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

void WarFileDriverFile::OnRead(const WarError& status, 
        war_transfer_buffer_ptr_t& buffer)
{
    mpCompanion->OnRead(status, buffer);
}

void WarFileDriverFile::OnWritten(const WarError& status,
        war_transfer_buffer_ptr_t& buffer)
{
    mpCompanion->OnWritten(status, buffer);
}


/////////////////////////////// PRIVATE    ///////////////////////////////////

