#include "StdAfx.h"
#include "WarIpAccessList.h"   // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarIpAccessList::WarIpAccessList()
: mMode(DEFAULT_ALLOW)
{
}// WarIpAccessList

WarIpAccessList::WarIpAccessList(const WarIpAccessList& from)
: mMode(from.mMode),
mIpList(from.mIpList)
{
}// WarIpAccessList

WarIpAccessList::~WarIpAccessList()
{
}// ~WarIpAccessList


//============================= OPERATORS ====================================

WarIpAccessList& WarIpAccessList::operator = (const WarIpAccessList& from)
{
    mMode = from.mMode;
    mIpList = from.mIpList;
    return *this;
}// =

//============================= OPERATIONS ===================================

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

bool WarIpAccessList::IsAllowed(const struct in_addr& hostAddr) const
{
    for(war_ip_mask_set_t::const_iterator 
        P = mIpList.begin()
        ; P != mIpList.end()
        ; ++P)
    {
        if (P->DoesInclude(hostAddr))
        {
            return (DEFAULT_ALLOW == mMode) 
                ? false : true;
        }
    }
    
    return (DEFAULT_ALLOW == mMode) ? true : false;
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

