#include "StdAfx.h"
#include "WarNtServiceMgr.h"   // class implemented

#ifndef WAR_COLLECTOR_H
#   include "WarCollector.h"
#endif


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarNtServiceMgr::WarNtServiceMgr()
: mhMgr(NULL), mLock(NULL)
{
}// WarNtServiceMgr

WarNtServiceMgr::~WarNtServiceMgr()
{
    if (mLock)
        UnlockServiceDatabase(mLock); 

    if (mhMgr)
        CloseServiceHandle(mhMgr);
}// ~WarNtServiceMgr


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

void WarNtServiceMgr::Create(war_ccsysstr_t machineName,
                             DWORD dwAccessType,
                             bool doLock) throw(WarException)
{
    bool rval = false;
    WarCollector<TCHAR> server;

    if (machineName && *machineName)
    {
        if (*machineName != '\\')
            server << "\\\\";
            
        server << machineName;
    }

    if ((mhMgr = OpenSCManager(server.GetValue().c_str(), 
        NULL, dwAccessType)) == NULL)
    {
        WarThrow(WarSystemError(), NULL);
    }

    if (doLock)
    {
        mLock = LockServiceDatabase(mhMgr);
        if (NULL == mLock)
            WarThrow(WarError(WAR_ERR_FAILED_TO_LOCK_OBJECT), "LockServiceDatabase()");
    }
}

//============================= CALLBACK   ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

