#include "StdAfx.h"
#include "WarPluginModule.h"   // class implemented

#ifndef WAR_PLUGIN_ENGINE_H
#   include "WarPluginEngine.h"
#endif

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarPluginModule::WarPluginModule(war_ccstr_t name)
: mName(name)
{
    WarPluginEngine& engine = WarPluginEngine::GetEngine();
    engine.RegisterPluginModule(this);
}// WarPluginModule

WarPluginModule::~WarPluginModule()
{
    WarPluginEngine& engine = WarPluginEngine::GetEngine();
    engine.UnregisterPluginModule(this);
}// ~WarPluginModule


//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================

void WarPluginModule::NotifyOnClassInstance(
    const war_ccstr_t className)
    throw(WarException)
{
    WarPluginEngine::GetEngine().NotifyOnClassInstance(this, className);
}

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

