#include "StdAfx.h"
#include "WarSessionManagerPlugins.h"   // class implemented

/////////////////////////////// PUBLIC ///////////////////////////////////////

void WarSessionManager_WarSvrEngine_OnAccept::OnProcess(
    const WarError& status,
    war_socket_t newSocket,
    const WarNetAddress& remoteAddress,
    const WarNetAddress& localAddress,
    WarSvrEngineSocket *pListenSck) 
    throw (WarException)
{
    mpManager->OnAccept(status,
        newSocket,
        remoteAddress,
        localAddress,
        pListenSck);
}

void WarSessionManager_WarSvrProtocol_OnClientConnect::OnProcess(
    WarSvrProtocol *pSvrProtocol) 
    throw (WarException)
{
    mpManager->OnClientConnect(pSvrProtocol);
}


void WarSessionManager_WarSvrProtocol_OnLoginPostAuth::OnProcess(
    WarSvrProtocol *pSvrProtocol,
    war_ccstr_t virtualHost, // Supplied by client
    war_ccstr_t userName, // Supplied by client
    war_ccstr_t userPasswd, // Supplied by client
    std::string& useUserName, // Used during authentication
    WarCollector<char>& useUserPasswd, // Used during authentication
    std::string& useVirtualHost, // Used during authentication
    WarSvrEnums::WarLoginResultE& loginResult, // Result from authentication
    war_auth_ptr_t& auth_module_ptr, // Result from authentication
    war_authdata_ptr_t& session_data_ptr) // Result from authentication
    throw (WarException)
{
    mpManager->OnPostLogin(useUserName,
        pSvrProtocol, 
        session_data_ptr,
        mNumFailedLoginAttepmts, 
        loginResult);

    if (WarSvrEnums::LF_OK == loginResult)
        mCurrentSucceededSession = pSvrProtocol->mSessionPtr;
}

WarSessionManager_WarSvrProtocol_OnLoginPostAuth::~WarSessionManager_WarSvrProtocol_OnLoginPostAuth()
{
    if (mCurrentSucceededSession)
        mpManager->OnClientLogoff(mCurrentSucceededSession);
}

void WarSessionManager_WarSvrProtocol_OnLogout::OnProcess(
    WarSvrProtocol *pSvrProtocol)
        throw (WarException)
{
    if (pSvrProtocol->mSessionPtr)
        mpManager->OnClientLogoff(pSvrProtocol->mSessionPtr);
}

