#include "StdAfx.h"
#include "WarSvrDefinition.h"   // class implemented

#ifndef WAR_SVR_PROTOCOL_H
#   include "WarSvrProtocol.h"
#endif

using namespace std;

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarSvrDefinition::WarSvrDefinition()
    throw(WarException)
{
}// WarSvrDefinition

//============================= OPERATORS ====================================

WarSvrProtocol *
WarSvrDefinition::CreateNewInstance(war_socket_io_ptr_t& companionPtr)
        throw(WarException)
{

    WarSvrProtocol *pProt = GetNewSvr(companionPtr);

    try
    {
        OnCreateNew(pProt);
    }
    catch(WarException& ex)
    {
        delete pProt;
        throw ex;
    }

    return pProt;
}

//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

std::string WarSvrDefinition::Explain() const
{
    return mLocalHost.Explain();
}

const std::string WarSvrDefinition::GetSiteName() const
{
    return mSiteName;
}

const std::string WarSvrDefinition::GetNativeSiteName() const
{
    return mNativeSiteName;
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

void WarSvrDefinition::OnCreateNew(WarSvrProtocol *newChild)
{
    newChild->mProperties += mProperties;
}

/////////////////////////////// PRIVATE    ///////////////////////////////////


