#include "StdAfx.h"
#include "WarSvrFile.h"   // class implemented


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarSvrFile::WarSvrFile()
: my_callback(NULL),
my_callback_arg(NULL)
{
}// WarSvrFile

WarSvrFile::~WarSvrFile()
{
}// ~WarSvrFile


//============================= OPERATORS ====================================

void WarSvrFile::Open(const WarSvrPath& filePath, 
        const war_uint32_t openFlags)
        throw(WarException)
{
    assert(IsOpen() == false);

    mSvrPath = filePath;
    CreateDriverForUrl(filePath.GetUrl());
    WarFile::Open(openFlags);

}

//============================= OPERATIONS ===================================

void WarSvrFile::AssignCallback(callback_t func, war_cptr_t arg)
{
    my_callback = func;
    my_callback_arg = arg;
}

void WarSvrFile::Close() 
    throw(WarException)
{
    my_callback = NULL;
    my_callback_arg = NULL;

    WarFile::Close();
}

//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////

void WarSvrFile::OnRead(const WarError& status, 
        war_transfer_buffer_ptr_t& buffer)
{
    if (my_callback == NULL)
        WarThrow(WarError(WAR_ERR_INTERNAL_DATA_NOT_INITIALIZED), NULL);
        
    my_callback(my_callback_arg, status, buffer);
}

void WarSvrFile::OnWritten(const WarError& status,
        war_transfer_buffer_ptr_t& buffer)
{
    if (my_callback == NULL)
        WarThrow(WarError(WAR_ERR_INTERNAL_DATA_NOT_INITIALIZED), NULL);
    
    my_callback(my_callback_arg, status, buffer);
}


/////////////////////////////// PRIVATE    ///////////////////////////////////

