#include "StdAfx.h"

#define WAR_FTP_OPTION_NAMES 1
#include "WarSvrProtocolFtpMode.h"   // class implemented

#ifndef WAR_COLLECTOR_H
#   include "WarCollector.h"
#endif


/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================


//============================= OPERATORS ====================================


//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

std::string WarSvrProtocolFtpMode::Explain() const
{
    WarCollector<char> buf;

    buf << "Type=" << war_typenames[mType] << "; "
        << "Form=" << war_formnames[mForm] << "; "
        << "Stru=" << war_strunames[mStru] << "; "
        << "Mode=" << war_modenames[mMode] << "; "
        << "TransferOperation=" << war_trop_names[mTransferOperation] << "; "
        << "ConnectionType=" << war_conn_modenames[mConnectionType] << "; "
        << "RestartPos=" << mRestartPos << "; "
        << "LocalAddress=" << mLocalAddress.Explain() << "; ";
    
    if (!mPortAddress.IsEmpty())
        buf << "PortAddress=" << mPortAddress.Explain() << "; ";

    return buf.GetValue();
}

war_ccstr_t 
WarSvrProtocolFtpMode::GetTypeName() const
{
    if ((mType < TYPE_ASCII) || (mType > TYPE_INVALID))
        WarThrow(WarError(WAR_ERR_OUT_OF_RANGE), NULL);

    return war_typenames[mType];
}

war_ccstr_t 
WarSvrProtocolFtpMode::GetModeName() const
{
    if ((mType < TYPE_ASCII) || (mType > TYPE_INVALID))
        WarThrow(WarError(WAR_ERR_OUT_OF_RANGE), NULL);

    return war_modenames[mType];
}

war_ccstr_t 
WarSvrProtocolFtpMode::GetStructureName() const
{
    if ((mType < TYPE_ASCII) || (mType > TYPE_INVALID))
        WarThrow(WarError(WAR_ERR_OUT_OF_RANGE), NULL);

    return war_strunames[mType];
}

war_ccstr_t 
WarSvrProtocolFtpMode::GetFormName() const
{
    if ((mType < TYPE_ASCII) || (mType > TYPE_INVALID))
        WarThrow(WarError(WAR_ERR_OUT_OF_RANGE), NULL);

    return war_formnames[mType];
}

/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

