/**
 */

#ifndef WAR_AUTO_COUNTER_H
#define WAR_AUTO_COUNTER_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_AUTO_LOCK
#   include "WarAutoLock.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

template <class T>
class WarAutoCounter 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarAutoCounter<T>(T& rCounterVar, 
        WarCriticalSection *pLock)
        : mrCounterVar(rCounterVar),
        mpLock(pLock)
    {
        WarAutoLock MyLock(mpLock);
        mrCounterVar++;
    }

    WarAutoCounter<T>(T& rCounterVar, 
        WarCriticalSection& rLock)
        : mrCounterVar(rCounterVar),
        mpLock(&rLock)
    {
        WarAutoLock MyLock(mpLock);
        mrCounterVar++;
    }
    
    /**
    * Destructor.
    */
    ~WarAutoCounter<T>(void)
    {
        WarAutoLock MyLock(mpLock);
        mrCounterVar--;
    }
    
    // OPERATORS
    operator T () const
    {
        WarAutoLock(mpLock) MyLock;
        return mrCounterVar;
    }

    // OPERATIONS                       
    // ACCESS
    // INQUIRY
    
protected:
private:
    T& mrCounterVar;
    WarCriticalSection *mpLock;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* _WAR_AUTO_COUNTER_H_ */

