/** 
*/

#ifndef WAR_AUTO_REF_H
#define WAR_AUTO_REF_H

/* SYSTEM INCLUDES */

#ifndef WAR_ASSERT_H_INCLUDED
#   include <assert.h>
#endif

/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

template <class CC, class RC>
class WarAutoRef 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    
    WarAutoRef()
        : mpContainer(NULL),
        mpReference(NULL)
    {
    }
    
    ///
    WarAutoRef(CC& rContainer, RC& rReference)
        : mpContainer(&rContainer),
        mpReference(&rReference)
    {
        mpContainer->Attach(mpReference);
    }
    
    /// Use if not initialized in constructor
    void Open(CC * pContainer, RC * pReference)
    {
        assert(NULL == mpContainer);
        assert(NULL == mpReference);
        assert(NULL != pContainer);
        assert(NULL != pReference);
        
        mpContainer = pContainer;
        mpReference = pReference;

        mpContainer->Attach(mpReference);
    }
    
    
    /**
    * Destructor.
    */
    ~WarAutoRef()
    {
        if (mpReference && mpContainer)
            mpContainer->Detach(mpReference);
    }
    
    // OPERATIONS                       
    // ACCESS
    // INQUIRY
    
protected:
private:
    CC * mpContainer;
    RC * mpReference;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_AUTO_REF_H_ */

