/** 
*/

#ifndef WAR_CLIENT_SESSION_H
#define WAR_CLIENT_SESSION_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SMART_POINTER_H
#   include "WarSmartPointer.h"
#endif

#ifndef WAR_NET_ADDRESS_H
#   include "WarNetAddress.h"
#endif

#ifndef WAR_TIME_H
#   include "WarTime.h"
#endif

#ifndef WAR_PTR_WRAPPER_H
#   include "WarPtrWrapper.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarClientSession : 
public WarSmartPointer
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarClientSession(const std::string& siteName, 
        const std::string& userName,
        const WarNetAddress& fromHost,
        const war_uint64_t& fromSocketSeqId);
        
    /**
    * Destructor.
    */
    ~WarClientSession();
    
    // OPERATORS 
    
    bool operator == (const WarClientSession& from)
    {
        return (mName == from.mName) 
            && (mSite == from.mSite);
    }

    bool operator < (const WarClientSession& from)
    {
        int cmp_val = strcmp(mSite.c_str(), from.mSite.c_str());
        if (0 > cmp_val)
            return true;
        if (0 < cmp_val)
            return false;

        return mName < from.mName;
    }

    // OPERATIONS
    // CALLBACK
    // ACCESS
    // INQUIRY

    war_uint64_t GetSeqNumber() const
    {
        return mSeqNumber;
    }

    war_uint64_t GetSocketSeqNumber() const
    {
        return mSocketSeqNumber;
    }

    const WarNetAddress& GetRemoteAddress() const
    {
        return mRemoteHost;
    }

    const std::string& GetNativeSiteName() const
    {
        return mSite;
    }
    
    const std::string& GetLoginName() const
    {
        return mName;
    }

    const WarTime& GetLoginTime() const
    {
        return mLoginTime;
    }

    std::string Explain() const;

protected:
private:
    static war_uint64_t sSeqCounter; 
    const std::string mName;
    const std::string mSite;
    const WarNetAddress mRemoteHost;
    const war_uint64_t mSeqNumber; 
    const war_uint64_t mSocketSeqNumber;
    const WarTime mLoginTime;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarPtrWrapper<WarClientSession> war_client_session_ptr_t;

template <class charT>
WarCollector<charT>& operator << (WarCollector<charT>& o,
                                  const WarClientSession& v)
{
    return o << v.Explain();
}

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_CLIENT_SESSION_H_ */

