/** 
*/

#ifndef WAR_FILE_DRIVER_WIN32_H
#define WAR_FILE_DRIVER_WIN32_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_FILE_DRIVER_H
#   include "WarFileDriver.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarFileDriverFileWin32;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarFileDriverWin32 : public WarFileDriver
{
public:
    // LIFECYCLE
     WarFileDriverWin32();
     ~WarFileDriverWin32() {}
    
    // OPERATORS
    // OPERATIONS                       
    virtual void WarListDirectory(const WarUrl& Path,
        WarDirList& listDestination)
        throw(WarException);
    virtual void WarDeleteFile(const WarUrl& Path) const
        throw(WarException);
    virtual void WarDeleteDirectory(const WarUrl& Path) const
        throw(WarException);
    virtual void WarCreateDirectory(const WarUrl& Path) const
        throw(WarException);
    virtual void WarCopyFile(const WarUrl& From, const WarUrl& To) const
        throw(WarException);
    virtual void WarMoveFile(const WarUrl& From, const WarUrl& To) const
        throw(WarException);
    virtual war_flen_t WarGetFreeSpaceOnPath(const WarUrl& Path) const
        throw(WarException);
    virtual war_flen_t WarGetSize(const WarUrl& Path) const
        throw(WarException);
    virtual void WarStat(const WarUrl& Path, war_stat_t& st) const
        throw(WarException);
    virtual void WarRenameDirectory(const WarUrl& From, const WarUrl& To) const
        throw(WarException);
    virtual bool LogonToUrl(const WarUrl& logonUrl) const;
    
    // Win32 spesific functions
    HANDLE WarFindFirstFile(const war_syspath_t& Path, WIN32_FIND_DATA *pData)
        throw(WarException);
    BOOL WarFindNextFile(HANDLE h, WIN32_FIND_DATA *pData)
        throw(WarException);

    // ACCESS

    virtual WarFileDriverFile *WarCreateNewFileObject() const
        throw(WarException);


    // INQUIRY
    virtual PathCmpTypeE WarGetCmpMode(const WarUrl& Path) const;
    virtual void WarGetFileModTime(const WarUrl& fsysUrl,
                      WarTime& outTime,
                      size_t& outPrecision) const
                      throw(WarException);
    
protected:
    friend WarFileDriverFileWin32;

private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_FILE_DRIVER_WIN32_H_ */

