/** 
*/

#ifndef WAR_FILE_ENUMS_H
#define WAR_FILE_ENUMS_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarFileEnums 
{
public:
    /// Path compare method
    enum PathCmpTypeE
    {
        /// Let the file system determine the type
        PCMP_AUTO,
        /// Case sensitive (UNIX)
        PCMP_CASE_SENSITIVE,
        /// Case insensitive (DOS)
        PCMP_CASE_INSENSITIVE
    };

    enum FileTypeE
    {
        /// Normal file
        FT_NORMAL,
        /// Directory
        FT_DIR,
        /// Link
        FT_LINK,
        /// UNIX special file
        FT_SPECIAL,
        /// Virtual directory with HIDE flag
        FT_HIDDEN_VDIR,
        /// File don't exist, or can't stat
        FT_VOID,
        ///
        FT_INVALID
    };
    
    ///
    enum SeekModes
    {
        ///
        WAR_SEEK_BEGIN,
        ///
        WAR_SEEK_CURRENT,
        ///
        WAR_SEEK_END
    };

    ///
    enum PositionModes
    {
        /// Physical offset
        MODE_BINARY,
        /// Logical offset (ascii mapping)
        MODE_ASCII
    };

    ///
    enum NameModes
    {
        /// /pub/cdrom1/test.htm
        NAME_LOGICAL_PATH,
        /// test.htm
        NAME_LOGICAL_NAME_ONLY,
        /// /pub/cdrom1
        NAME_LOGICAL_PATH_ONLY,
        /// vfsys://pub/cdrom/test.htm
        NAME_URL,
        /// c:\ftp\pub\cdrom1\test.htm
        NAME_PHYSICAL_PATH,
        /// test.htm
        NAME_PHYSICAL_NAME_ONLY,
        /// c:\ftp\pub\cdrom1
        NAME_PHYSICAL_PATH_ONLY,
        /// c:\ ..
        NAME_PHYSICAL_DRIVE,
        /// htm
        NAME_PHYSICAL_EXTENSION_ONLY,
        /// vfsys
        NAME_PROTOCOL
    };

    enum
    {
        /**@name General */ //@{
        ///
        F_CALLBACK = 0x00000001,
        //@}

        /**@name Permissions */ //@{
        ///
        F_READ = 0x00000002,
        ///
        F_WRITE = 0x00000004,
        ///
        F_APPEND = 0x00000008,
        /// Check for delete perms, don't delete the file/dir
        F_UNLINK = 0x00040000,
        /// Check for execute/chdir perms
        F_EXECUTE = 0x00080000,
        //@}

        /**@name Sharing */ //@{
        ///
        F_SHREAD = 0x00000010,
        ///
        F_SHWRITE = 0x00000020,
        ///
        F_EXCLUSIVE = 0x00000040,
        //@}

        /**@name Mapping */ //@{
        ///
        F_TEXT = 0x00000080,
        //@}

        /**@name Create mode */ //@{
        ///
        F_CREATE = 0x00000100,
        ///
        F_NOTEXIST = 0x00000200,
        ///
        F_MUSTEXIST = 0x00000400,
        ///
        F_TRUNCATE = 0x00000800,
        //@}

        /**@name Optimizing hints */ //@{
        ///
        F_SEQUENTIAL = 0x00001000,
        ///
        F_TEMPORARY = 0x00002000,
        //@}

        /** Special */ //@{
        /// Check ratio (download)
        F_RATIO = 0x00020000
        //@}
    };

    enum DirListFlagsE
    {
        /// Hide files beginning with a single '.'
        DIRF_HIDE_DOT_FILES     = 0x00000001,
        /// Hide . and ..
        DIRF_HIDE_DOT_DOTDOT    = 0x00000002,
        /** Hide files marked as HIDDEN by the system.
          * This includes files beginning with a single
          * . on UNIX systems.
          */
        DIRF_HIDE_HIDDEN        = 0x00000004,

        DIRF_RECURSIVE          = 0x00000008,

        /** Try safe pattern matching, as used
          * by many FTP clients. We only
          * allow pattern matching at the
          * file/dir name level, and not on
          * the path. This is both to avoid
          * exploids, and to limit the "featured"
          * DoS attacks we can expect.
          */
        DIRF_TRY_SAFE_PATTERNS  = 0x00000010
    };


    // LIFECYCLE
    // OPERATIONS                       
    // ACCESS
    // INQUIRY
    
protected:
private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_FILE_ENUMS_H_ */

