/* 
    WarGetopt implements a tread-safe getopt_long()
    function, using the same source as the generic 
    C port of the function. 

    The class implementation is designed for C++ classes
    that parses command-line options.
*/
#ifndef WAR_GETOPT_H
#define WAR_GETOPT_H

#ifndef GETOPT_H_INCLUDED
#   ifdef HAVE_GETOPT_H
#       define GETOPT_H_INCLUDED
#       include <getopt.h>
#else
#       include "jgaa/getopt.h"
#   endif
#endif

#define WAR_GETOPT_CLASS

class WarGetopt
{
public:    
    WarGetopt()
        : optarg(NULL), 
        optind(0),
        opterr(1),
        optopt(0),
        opt_idx(0)
    {}

    int GetoptErr(int ch, int arg, const char *parg);
    int GetoptLong(int argc,
                char * const argv[],
                const char *optstring,
                const struct option *longopts,
                int *longindex);

    const char *optarg;
    int optind, opterr, optopt;
private:
    int opt_idx;
};

#endif // WAR_GETOPT_H

