/** 
*/

#ifndef WAR_IF_AUTH_MODULE_H
#define WAR_IF_AUTH_MODULE_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_IF_SITE_H
#   include "WarIfSite.h"
#endif

#ifndef WAR_USER_AUTH_H
#   include "WarUserAuth.h"
#endif

#ifndef WAR_IF_USER_H
#   include "WarIfUser.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarIfAuthModule : public WarSmartPointer
{
public:
    enum AuthModuleTypeE
    {
        AMT_WINNT,
        AMT_INVALID
    };
    // LIFECYCLE
    // OPERATORS 
    // OPERATIONS

    void SetEnable(const bool doEnable = true) throw(WarException);
    void SetName(war_ccsysstr_t newName) throw(WarException);

    // CALLBACK
    // ACCESS

    WarUserAuth& GetAuth() throw(WarException)
    {
        return *mAuthPtr;
    }
    
    WarIfSite& GetSite() throw(WarException)
    {
        return *mSitePtr;
    }


    // INQUIRY

    bool IsEnabled() const;
    
    war_ccsysstr_t GetName() const;
    
    war_ccsysstr_t GetModuleTypeName() const;
    
    AuthModuleTypeE GetType() const {return mType;}

    void EnumUsers(war_if_user_set_t& user_set,
        bool doIgnoreDisabledUsers = false) throw(WarException);
    
protected:
    friend WarIfSite;
    WarIfAuthModule();

    void Open(war_if_site_ptr_t& sitePtr, 
        const WarWin32Registry& regKey)
        throw(WarException);

    ~WarIfAuthModule();

private:
    war_if_site_ptr_t mSitePtr;
    WarWin32Registry mRegKey;
    war_user_auth_ptr_t mAuthPtr;
    war_regstr_t mName; 
    war_regstr_t mTypeName; 
    AuthModuleTypeE mType;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarPtrWrapper<WarIfAuthModule> war_if_aut_module_ptr_t;
typedef std::list<war_if_aut_module_ptr_t> war_if_aut_module_list_t;

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_IF_AUTH_MODULE_H_ */

