/** 
*/

#ifndef WAR_IF_LOG_MODULE_H
#define WAR_IF_LOG_MODULE_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_WIN32_REGISTRY_H
#   include "WarWin32Registry.h"
#endif

#ifndef WAR_PTR_WRAPPER_H
#   include "WarPtrWrapper.h"
#endif

#ifndef WAR_SMART_POINTER_H
#   include "WarSmartPointer.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */


#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarIfLogModule : 
public WarSmartPointer
{
public:
    // LIFECYCLE
    // OPERATORS
    // OPERATIONS
    // CALLBACK
    // ACCESS

    void SetEnable(const bool doEnable = true);
    void SetFileName(const war_regstr_t& fileName) const;
    void SetTagName(const war_regstr_t& fileName) const;
    void SetEvents(const war_regstr_t& newEvents) const;

    // INQUIRY
    bool IsEnabled() const;
    war_regstr_t GetClsid() const;
    war_regstr_t GetFileName() const;
    bool HaveFileName() const;
    war_regstr_t GetTagName() const;
    bool HaveTagName() const;
    war_regstr_t GetEvents() const;
    war_ccsysstr_t GetName() const;

protected:
    ~WarIfLogModule();

    friend class WarIfServer;
    WarIfLogModule();
    void Open(const WarWin32Registry& parentKey, 
        war_ccsysstr_t logName)
        throw(WarException);

private:
     WarWin32Registry mRegKey;
     war_regstr_t mName;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarPtrWrapper<WarIfLogModule> war_if_log_module_ptr_t;

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_IF_LOG_MODULE_H_ */

