/** 
*/

#ifndef WAR_IF_OPTIONS_H
#define WAR_IF_OPTIONS_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


#ifndef WAR_PTR_WRAPPER_H
#   include "WarPtrWrapper.h"
#endif

#ifndef WAR_SMART_POINTER_H
#   include "WarSmartPointer.h"
#endif

#ifndef WAR_OPTION_H
#   include "WarOption.h"
#endif

#ifndef WAR_IF_SERVER_H
#   include "WarIfServer.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarIfOptions : 
public WarSmartPointer
{
public:
    typedef struct
    {
        std::string mName;
        std::string mDefaultValue;
        std::string mDescription;
        WarOption::WarOptionTypeE mType;
        WarOption::OptLevelE mLevel;
    } option_def_t;
    
    typedef std::list<option_def_t> option_def_list_t;

    // LIFECYCLE
    /**
    * Default constructor.
    */
      
    /**
    * Destructor.
    */
    ~WarIfOptions();
    
    // OPERATORS
    // OPERATIONS

    void EnumOptions(option_def_list_t& optionList) const;

    void SetOption(const std::string& optionName, 
        const std::string& optionValue);

    void SetIntOption(const std::string& optionName, 
        const int optionValue);

    // Set to use the default/inherited option
    void ClearOption(const std::string& optionName);

    // CALLBACK
    // ACCESS

    const WarIfServer& GetServer() const;

    // INQUIRY

    std::string GetOption(const std::string& optionName) const;

    bool HasOwnOption(const std::string& optionName) const;

    int GetIntOption(const std::string& optionName) const;
    
protected:
    friend class WarIfUser;
    friend class WarIfServer;
    friend class WarIfSite;
    WarIfOptions(WarIfServer& serverRef);
    WarIfOptions(WarIfSite& serverRef);
    WarIfOptions(WarIfUser& userRef);

private:
    WarWin32Registry mRegKey;
    war_if_server_ptr_t mServerPtr;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarPtrWrapper<WarIfOptions> war_if_options_ptr_t;

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_IF_OPTIONS_H_ */

