
#ifndef WAR_ITOA_H
#define WAR_ITOA_H

template < class numT >
int
WarDoDivi (numT & n, int base)
{
    numT res;
    res = n % (numT) base;
    n = n / (numT) base;
    return res;
}

/** Generic itoa() function. Handles any integer supported by the compiler
    
    @param dst String to write to. Also returden
    @param val Value to convert to a string
    @param base Number system, 10 or 16
    @param large_digits true if hex letters is LARGE else they are small
    @param fmt_char Format character. Used to make: 1.234.567 style formatting.
    @return The formatted string. The buffer passed as dst is returned.
*/
template < class charT, class numT >
std::basic_string < charT > &
WarItoa(std::basic_string < charT > &dst,
          const numT val,
          const int base = 10,
          const bool large_digits = true,
          char fmt_char = 0)
{
    static const char s_digits[] = "0123456789abcdefghijklmnopqrstuvwxyz";
    static const char l_digits[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    char buf[64];
    war_cstr_t p = buf;
    war_ccstr_t digits = large_digits ? l_digits : s_digits;
    bool IsNegative = 0;
    numT my_val = val;

    if (my_val < 0)
    {
        my_val *= -1;
        IsNegative = true;
    }

    if (my_val == 0)
        *p++ = '0';
    else
        while (my_val != 0)
            *p++ = digits[WarDoDivi(my_val, base)];

    if (IsNegative)
        *p++ = '-';

    *p = 0;

    int cnt = fmt_char ? (3 - (strlen(buf) % 3)) : 0;
    for (int i = (p - buf) - 1; i >= 0; i--)
    {
        if (fmt_char && !(cnt++ % 3))
            dst += '.';
        dst += buf[i];
    }

    return dst;
}


#endif // #ifndef WAR_ITOA_H

