
#ifndef WAR_WARLOG_EVENT_H
#define WAR_WARLOG_EVENT_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SMART_PINTER_H
#   include "WarSmartPointer.h"
#endif

#ifndef WAR_ERROR_H
#   include "WarError.h"
#endif

#ifndef WAR_STRING_INCLUDED
#   define WAR_STRING_INCLUDED
#   include <string>
#endif

#ifndef WAR_TIME_H
#   include "WarTime.h"
#endif

#ifndef WAR_WARLOG_EVENTDATA_H
#   include "WarLogEventData.h"
#endif

#ifndef WAR_PTR_WRAPPER_H
#   include "WarPtrWrapper.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/



/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

/** Carrier of the information about a single log-event.
  * It is created by WarLog, and sent to the chain of
  * log-event handlers.
  */
class WarLogEvent : public WarSmartPointer, 
    public WarLogEventData
{
public:
    // LIFECYCLE
    
    /** Copy constructor.
    *
    * @param from The value to copy to this object.
    */
    WarLogEvent(const WarLogEventData& from)
        : WarLogEventData(from)
    {}

    
    // OPERATORS
    
    /**
    * Assignment operator.
    *
    * @param from THe value to assign to this object.
    *
    * @return A reference to this object.
    */
    WarLogEvent& operator=(WarLogEvent& from)
    {
        WarLogEventData::operator=(from);
        return *this;
    }
    
    // OPERATIONS                       
    // ACCESS
    // INQUIRY    
    
protected:
    
private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarPtrWrapper<WarLogEvent> war_logevent_ptr_t;

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* _WAR_WARLOG_EVENT_H_ */

