/** Log event handler for C++ ostream. 
 */

#ifndef WAR_LOG_IOSTREAM_HANDLER_H
#define WAR_LOG_IOSTREAM_HANDLER_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_LOG_EVENT_HANDLER_H
#   include "WarLogEventHandler.h"
#endif

#ifndef WAR_LOG_H
#   include "WarLog.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarLogIoStreamHandler : public WarLogEventHandler
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarLogIoStreamHandler(std::ostream& rIo, 
        war_ccstr_t name)
        : WarLogEventHandler(name),
        mrIo(rIo)
    {}
    
    // OPERATORS
    // OPERATIONS                       
    // ACCESS
    // INQUIRY
    
protected:
    virtual void OnEvent(WarLogEvent& logEvent)
    {        
        if (!(GetSupressFlags() & SUPRESS_PREFIX))
        {
            if (!(GetSupressFlags() & SUPRESS_TYPE))
                mrIo << WarLog::sTypeChr[logEvent.mType] << ' ';
            
            if (!(GetSupressFlags() & SUPRESS_DATE))
                mrIo << logEvent.mTime.FormatLT("%c ");  
        }
                
        if (!(GetSupressFlags() & SUPRESS_ERROR) 
            && logEvent.mError)
            mrIo << '{' 
                << logEvent.mError.Explain() 
                << "} ";
        
        if (!(GetSupressFlags() & SUPRESS_PREFIX)
            && !(GetSupressFlags() & SUPRESS_MODULE)
            && !logEvent.mCallingFunc.empty())
        {
            mrIo << '[' 
                << logEvent.mCallingFunc 
                << "] ";
        }
        
        mrIo << logEvent.mMessage << std::endl;
    }
private:
    std::ostream& mrIo;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_LOG_IOSTREAM_HANDLER_H_ */

