/** NT performance monitor setup
  *
  */

#ifndef WAR_PERFMON_DEF_H
#define WAR_PERFMON_DEF_H

#ifdef WAR_WINNT
#   ifndef WAR_PERFMON_MAP_H
#       include "WarPerfmonMap.h"
#   endif

#   define WAR_PERFMON_SET(ref, value) \
        {if (g_PrfData.IsInitialized()) { \
            g_PrfData.LockCtrs(); \
            g_PrfData.GetCtr32(ref) = value; \
            g_PrfData.UnlockCtrs(); }}

#   define WAR_PERFMON_INC(ref) \
        {if (g_PrfData.IsInitialized()) { \
            g_PrfData.LockCtrs(); \
            g_PrfData.GetCtr32(ref)++; \
            g_PrfData.UnlockCtrs(); }}

#   define WAR_PERFMON_DEC(ref) \
        {if (g_PrfData.IsInitialized()) { \
            g_PrfData.LockCtrs(); \
            g_PrfData.GetCtr32(ref)--; \
            g_PrfData.UnlockCtrs(); }}

#   ifdef _DEBUG

#       define WAR_DB_PERFMON_SET(ref, value) \
            WAR_PERFMON_SET(ref, value)

#       define WAR_DB_PERFMON_INC(ref) \
            WAR_PERFMON_INC(ref)

#       define WAR_DB_PERFMON_DEC(ref) \
            WAR_PERFMON_DEC(ref)

#   else // ! _DEBUG

#       define WAR_DB_PERFMON_SET(ref, value) 
#       define WAR_DB_PERFMON_INC(ref)
#       define WAR_DB_PERFMON_DEC(ref)

#   endif // _DEBUG

#else // Win9x

#   define WAR_PERFMON_SET(ref, value) 
#   define WAR_PERFMON_INC(ref)
#   define WAR_PERFMON_DEC(ref)
#   define WAR_DB_PERFMON_SET(ref, value) 
#   define WAR_DB_PERFMON_INC(ref)
#   define WAR_DB_PERFMON_DEC(ref)

#endif // WAR_WINNT


# endif // WAR_PERFMON_DEF_H

