/** Abstract base class for plugin modules
*/

#ifndef WAR_PLUGIN_MODULE_H
#define WAR_PLUGIN_MODULE_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_PTR_WRAPPER_H
#   include "WarPtrWrapper.h"
#endif

#ifndef WAR_SMART_POINTER_H
#   include "WarSmartPointer.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarPluginBaseSupport;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarPluginModule
{
public:
    enum NotificationE
    {
        NOTIFY_CREATED,
        NOTIFY_DELETED
    };
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarPluginModule(war_ccstr_t name)
        throw (WarException);
    
    /**
    * Destructor.
    */
    virtual ~WarPluginModule();
    
    // OPERATORS
    // OPERATIONS

    void NotifyOnClassInstance(const war_ccstr_t className)
        throw(WarException);

    // CALLBACK

    virtual void OnClassInstance(WarPluginBaseSupport *pClassInstance,
        const NotificationE notificationType)
        throw(WarException) = 0; // Should not throw

    // ACCESS
    // INQUIRY
    
protected:

private:
    const std::string mName; // Name of this module
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarPtrWrapper<WarPluginModule> war_plugin_module_ptr_t;

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_PLUGIN_MODULE_H_ */

