/** 
*/

#ifndef WAR_SESSION_MANAGER_PLUGINS_H
#define WAR_SESSION_MANAGER_PLUGINS_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SVR_ENGINE_H
#   include "WarSvrEngine.h"
#endif

/* LOCAL INCLUDES */

#ifndef WAR_SESSION_MANAGER_H
#   include "WarSessionManager.h"
#endif

#ifndef WAR_SVR_PROTOCOL_H
#   include "WarSvrProtocol.h"
#endif



/* FORWARD REFERENCES */

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus


/** Called each time a client connects to the server,
  * before anything is done.
  */
class WarSessionManager_WarSvrEngine_OnAccept : 
public WarSvrEngine_OnAccept
{
public:
    WarSessionManager_WarSvrEngine_OnAccept(
        WarSessionManager *pManager) :
    mpManager(pManager)
    {
    }

    virtual void OnProcess(const WarError& status,
        war_socket_t newSocket,
        const WarNetAddress& remoteAddress,
        const WarNetAddress& localAddress,
        WarSvrEngineSocket *pListenSck) 
        throw (WarException);

private:
    WarSessionManager *mpManager;
};

class WarSessionManager_WarSvrProtocol_OnClientConnect :
public WarSvrProtocol_OnClientConnect
{
public:
    WarSessionManager_WarSvrProtocol_OnClientConnect(
        WarSessionManager *pManager) :
    mpManager(pManager)
    {}
    
    virtual void OnProcess(WarSvrProtocol *pSvrProtocol) 
        throw (WarException);
private:
    WarSessionManager *mpManager;
};

class WarSessionManager_WarSvrProtocol_OnLoginPostAuth :
public WarSvrProtocol_OnLoginPostAuth
{
public:
    WarSessionManager_WarSvrProtocol_OnLoginPostAuth(
        WarSessionManager *pManager) :
    mpManager(pManager), mNumFailedLoginAttepmts(0)
    {}

    ~WarSessionManager_WarSvrProtocol_OnLoginPostAuth();
    
    // WAR_ERR_PLUGIN_DONE is not supported here
    // Set the value in loginResult if login must
    // be denied!
    virtual void OnProcess(WarSvrProtocol *pSvrProtocol,
        war_ccstr_t virtualHost, // Supplied by client
        war_ccstr_t userName, // Supplied by client
        war_ccstr_t userPasswd, // Supplied by client
        std::string& useUserName, // Used during authentication
        WarCollector<char>& useUserPasswd, // Used during authentication
        std::string& useVirtualHost, // Used during authentication
        WarSvrEnums::WarLoginResultE& loginResult, // Result from authentication
        war_auth_ptr_t& auth_module_ptr, // Result from authentication
        war_authdata_ptr_t& session_data_ptr) // Result from authentication
        throw (WarException);
private:
    WarSessionManager *mpManager;
    int mNumFailedLoginAttepmts;
    war_client_session_ptr_t mCurrentSucceededSession;
};

class WarSessionManager_WarSvrProtocol_OnLogout :
public WarSvrProtocol_OnLogout
{
public:
    WarSessionManager_WarSvrProtocol_OnLogout(
        WarSessionManager *pManager) :
    mpManager(pManager)
    {}
    
    // WAR_ERR_PLUGIN_DONE is not supported here
    // Set the value in loginResult if login must
    // be denied!
    virtual void OnProcess(WarSvrProtocol *pSvrProtocol)
        throw (WarException);
private:
    WarSessionManager *mpManager;
};


#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SESSION_MANAGER_PLUGINS_H_ */

