/** This is a generic object that contains a
    repository for functions to call when a 
    program needs to shut down. 

    The different modules register themself here
    if there is any particular action that must
    be done when the program wanst to end, and
    the registered function will be called, one
    at the time, when Shutdown() is called.
*/

#ifndef WAR_SHUTDOWN_ENGINE_H
#define WAR_SHUTDOWN_ENGINE_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SHUTDOWN_ENGINE_TASK_H
#   include "WarShutdownEngineTask.h"
#endif

#ifndef WAR_SHUTDOWN_EVENT_H
#   include "WarThreadEvent.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarShutdownEngine
{
public:
    typedef std::list<war_shutdown_task_ptr_t> tasklist_t;

    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarShutdownEngine();

    ~WarShutdownEngine();

    // OPERATORS    
    // OPERATIONS

    void AddEvent(war_shutdown_task_ptr_t& taskPtr);
    void AddEvent(WarShutdownProc func, war_cptr_t parg);
    void DeleteEvent(war_shutdown_task_ptr_t& taskPtr);
    void Shutdown();
    void StartShutdown(); // Start shutdown in an independent thread
    void WaitForShutdown();

    // CALLBACK
    // ACCESS

    static WarShutdownEngine& GetEngine();

    // INQUIRY
    
protected:

private:
    static WarShutdownEngine *mspEngine;
    WarCriticalSection mLock;
    tasklist_t mTasks;
    WarThreadEvent mShutdownEvent;
    bool mIsShuttingDown;
    bool mHaveShutDown;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */


#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SHUTDOWN_ENGINE_H_ */

