/** 
*/

#ifndef WAR_SHUTDOWN_ENGINE_TASK_H
#define WAR_SHUTDOWN_ENGINE_TASK_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SMART_POINTER_H
#   include "WarSmartPointer.h"
#endif

#ifndef WAR_PTR_WRAPPER_H
#   include "WarPtrWrapper.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/

typedef void (*WarShutdownProc)(war_cptr_t parg);


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarShutdownEngineTask 
: public WarSmartPointer
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarShutdownEngineTask(WarShutdownProc pfunc, 
        war_cptr_t parg)
        : mShutdownFunc(pfunc),
        mArgp(parg)
    {
    }
    
    // OPERATORS    
    // OPERATIONS

    void Shutdown()
    {
        mShutdownFunc(mArgp);
    }

    // CALLBACK
    // ACCESS
    // INQUIRY
    
protected:
    ~WarShutdownEngineTask() {}

private:
    WarShutdownProc mShutdownFunc;
    war_cptr_t mArgp;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarPtrWrapper<WarShutdownEngineTask> war_shutdown_task_ptr_t;

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SHUTDOWN_ENGINE_TASK_H_ */

