/** 
  
    Listenig socket for the WarSvrEngine object.
*/

#ifndef WAR_SVR_ENGINE_SOCKET_H
#define WAR_SVR_ENGINE_SOCKET_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SOCKET_H
#   include "WarSocket.h"
#endif

#ifndef WAR_SVR_DEFINITION_H
#   include "WarSvrDefinition.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarSvrEngine;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarSvrEngineSocket : public WarSocket
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarSvrEngineSocket(WarSvrEngine *pEngine,
        war_svrdef_ptr_t& svrDefPtr,
        war_socket_io_ptr_t& companionPtr);
    
  
    /**
    * Destructor.
    */
    ~WarSvrEngineSocket(void);
    
    // OPERATORS
    
    /**
    * Assignment operator.
    *
    * @param from THe value to assign to this object.
    *
    * @return A reference to this object.
    */
    WarSvrEngineSocket& operator=(WarSvrEngineSocket& from);
    
    // OPERATIONS 
    // ACCESS

    WarSvrDefinition& GetSvrDefinition()
    {
        return *mSvrDefPtr;
    }

    // INQUIRY
    
protected:
    virtual void OnAccept(const WarError& status,
        war_socket_t newSocket,
        const WarNetAddress& remoteAddress,
        const WarNetAddress& localAddress);

private:
    WarSvrEngine *mpEngine;
    war_svrdef_ptr_t mSvrDefPtr;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WarSvrEngineSocket_h_ */

