/** 
*/

#ifndef WAR_SVR_PROPERTIES_H
#define WAR_SVR_PROPERTIES_H

/* SYSTEM INCLUDES */

#ifndef WAR_SET_INCLUDED
#   define WAR_SET_INCLUDED
#   include <set>
#endif

/* PROJECT INCLUDES */

#ifndef WAR_SVR_PATH_H
#   include "WarSvrPath.h"
#endif

#ifndef WAR_OPTION_LIST_H
#   include "WarOptionList.h"
#endif

#ifndef WAR_IP_ACCESS_LIST_H
#   include "WarIpAccessList.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarSvrProperties : public WarSvrEnums
{
public:
    typedef war_svr_pathset_t path_set_t;
    
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarSvrProperties(void);
    
    /**
    * Copy constructor.
    *
    * @param from The value to copy to this object.
    */
    WarSvrProperties(const WarSvrProperties& from);
    
    /**
    * Destructor.
    */
    ~WarSvrProperties(void);
    
    // OPERATORS

    /** Add values in 'from' where the keys don't exist
      * in the original object.
      *
      * Ie. If an path or option already is defined in
      * the object, it is not changed.
      */
    WarSvrProperties& operator += (const WarSvrProperties& from);
    
    /**
    * Assignment operator.
    *
    * @param from THe value to assign to this object.
    *
    * @return A reference to this object.
    */
    WarSvrProperties& operator=(WarSvrProperties& from);
    
    // OPERATIONS                       
    // ACCESS
    // INQUIRY

    WarSvrPath ResolvPath(const WarSvrPath::path_t srchPath) const;
    
    path_set_t mPaths;
    WarOptionList mOptions;
    WarIpAccessList mIpAccessList;

private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SVR_PROPERTIES_H_ */

