/** 
*/

#ifndef WAR_SVR_PROTOCOL_FTP_ENUMS_H
#define WAR_SVR_PROTOCOL_FTP_ENUMS_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/

#if WAR_FTP_OPTION_NAMES
    static char *war_typenames[] = {"ASCII", "EBCDIC", "BINARY", "Local", "Invalid" };
    static char *war_formnames[] =  {"Nonprint", "Telnet", "Carriage-control", "Invalid" };
    static char *war_strunames[] = {"File", "Record", "Page", "Invalid" };
    static char *war_modenames[] = {"Stream", "Block", "Compressed", "Invalid" };
    static char *war_trop_names[] = {"normal", "resume", "append", "unique"};
    static char *war_conn_modenames[] = {"active", "passive", "unknown"};
#endif

/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarSvrProtocolFtpEnums
{
public:
    // LIFECYCLE
    
   /// FTP server messages
    enum FtpSvrMsgsE
    {
        SM_WELCOME, ///
        SM_WELCOME_STELTH, ///
        SM_GENERIC_FAIL, ///
        SM_IDLE_TIMEOUT, ///
        SM_CTRLC_CLOSED_ERR, ///
        SM_HACKER_BUFFER_ATTACK, ///
        SM_ERR_EMPTY_CMD, ///
        SM_USE_ABOR, ///
        SM_NEED_PASSWD, ///
        SM_NEED_EMAIL, ///
        SM_ERR_BYE, ///
        SM_DONT_KNOW_YOU,///
        SM_RIGHT_PLACE_WRONG_TIME, ///
        SM_BAD_IP, ///
        SM_HACKERS_NOT_WELCOME, ///
        SM_TOO_MANY_FAILED_LOGINS, ///
        SM_TMC_ACCOUNT, ///
        SM_TMC_TOTAL, ///
        SM_TMC_IP, ///
        SM_SHUTTING_DOWN, ///
        SM_ANON_DENIED, ///
        SM_PASSWD_NOT_ACCEPTED,///
        SM_LOGGED_IN, ///
        SM_ALREADY_LOGGED_ON, ///
        SM_BAD_SEQ_OF_CMDS, ///
        SM_MISSING_PARAMETER_IN_CMD, ///
        SM_UNKNOWN_CMD,///
        SM_PARAMETER_NOT_SUPPORTED,
        SM_BAD_LEVEL, ///
        SM_UNKNOWN_PARAMETER, ///
        SM_CMD_NOT_IMPLEMENTERD, ///
        SM_GOODBYE_QUIT, ///
        SM_ACCT_OK, ///
        SM_REIN_OK, ///
        SM_PORT_DISABLED, ///
        SM_PORT_OK, ///
        SM_PASV_DISABLED, ///
        SM_PASV_FLOOD, ///
        SM_PASV_OK, // 
        SM_TYPE_A, ///
        SM_TYPE_I, ///
        SM_TYPE_L8, ///
        SM_TYPE_E, ///
        SM_STRU_OK, ///
        SM_MODE_S, ///
        SM_NO_FILE_OR_N0_ACCESS, ///
        SM_NAME_EXIST_DENIED_ACCESS, ///
        SM_THE_PATH_IS_A_DIR, ///
        SM_NOT_A_REGULAR_FILE, ///
        SM_THE_FILE_IS_TOO_LARGE_FOR_ASCII, ///
        SM_ACCESS_DENIED, //
        SM_REST_OK, ///
        SM_ABOR_OK_NO_TRANS, ///
        SM_CWD_FAIL, ///
        SM_CWD_OK, ///
        SM_LIST_FAIL, ///
        SM_NOOP_OK, ///
        SM_NOOP_OK_NORESET, ///
        SM_PWD_OK, ///
        SM_SYST_OK_IDLE, ///
        SM_SYST_OK_IDLE_STELTH, /// 
        SM_SERVER_SHUTTING_DOWN, ///
        SM_STARTING_RETR, ///
        SM_STARTING_STOU, ///
        SM_STARTING_SEND, ///
        SM_TRANSFER_DONE_OK, ///
        SM_TRANSFER_FAILED, //
        SM_CMD_NOT_ALLOWED_DURING_XMIT, ///
        SM_SERVER_CONFIGURATION_ERROR, ///
        SM_ILLEGAL_PATH, ///
        SM_RECURSIVE_LISTINGS_FORBIDDEN, ///
        SM_COMMAND_FORBIDDEN, ///
        SM_NO_ASCII_RESTART, ///
        SM_RESTART_OUT_OF_RANGE, ///
        SM_HELP_ALL, ///
        SM_ALLO_OK, ///
        SM_ALLO_FAIL, ///
        SM_ALLO_NOT_IMPLEMENTED_PARAM, ///
        SM_RNFR_OK, ///
        SM_BAD_SEQUENCE_OF_COMMANDS, ///
        SM_RNTO_NOT_SAME_DEVICE, ///
        SM_RNTO_OK, ///
        SM_DESTINATION_EXIST, ///
        SM_ABOR_INTERRUPTED, ///
        SM_ABOR_OK, ///
        SM_DELETE_OK, ///
        SM_DELE_FAILED, ///
        SM_DELE_FAILED_IS_DIR, ///
        SM_RMD_OK, ///
        SM_RMD_FAILED, ///
        SM_RMD_FAILED_IS_FILE, /// 
        SM_MKD_OK, ///
        SM_MKD_FAILED, ///
        SM_MKD_FAILED_PATH_EXIST, ///
        SM_STATUS_IDLE, ///
        SM_STATUS_IDLE_STELTH, ///
        SM_STATUS_WITH_ARGUMENT_IS_FILE, ///
        SM_STATUS_WITH_ARGUMENT_IS_DIR, ///
        SM_STATUS_WITH_ARGUMENT_FAILED_TYPE, ///
        SM_STATUS_WITH_ARGUMENT_FAILED_VOID, ///
        SM_STATUS_TRANSFER, ///
#if WAR_RFC2389
        SM_FEAT_OK, ///
        SM_OPTS_OK,
        SM_OPTS_FAILED,
#endif
#if WAR_RFC2577
        SM_PORT_RESTRICTED, ///
        SM_INVALID_IP_ADDRESS,
        SM_NO_FTP_PROXY,
#endif
        SM_INVALID
    };
    
    enum WarFTPDReplyCodesE
    {
        FTPR_USING_OPEN_CONN_OK_125 = 125,
        FTPR_OPENING_CONN_OK_150 = 150,
        FTPR_OK_200 = 200,
        FTPR_NOT_IMPLEMENTED_202 = 202,
        FTPR_STAT_211 = 211,
        FTPR_STAT_DIR_212 = 212,
        FTPR_STAT_FILE_213 = 213,
        FTPR_HELP_214 = 214,
        FTPR_NAME_OK_215 = 215,
        FTPR_READY_220 = 220,
        FTPR_QUIT_221 = 221,
        FTPR_TRANSFER_OK_226 = 226,
        FTPR_PASV_OK_227 = 227,
        FTPR_LOGIN_OK_230 = 230,
        FTPR_FILE_ACTION_OK_250 = 250,
        FTPR_NEED_PASSWORD_331 = 331,
        FTPR_PATHNAME_OK_257 = 257,
        FTPR_PENDING_OK_350 = 350,
        FTPR_BYE_421 = 421,
        FTPR_CANT_OPEN_DATACONN_425 = 425,
        FTPR_TRANSFER_ABORTED_DATACONN_CLOSED_426 = 426,
        FTPR_ABORT_451 = 451,
        FTPR_SYNTAX_ERR_500 = 500,
        FTPR_ARG_SYNTAX_501 = 501,
        FTPR_NOT_IMPL_502 = 502,
        FTPR_BAD_SEQ_503 = 503,
        FTPR_CMD_NOT_IMPL_ARG_504 = 504,
        FTPR_NOT_LOGGED_IN_530 = 530,
        FTPR_ACCESS_DENIED_550 = 550,
        FTPR_INVALID = 0
    };

    enum TypeE
    {
	    TYPE_ASCII,			/* ASCII */
	    TYPE_EBCDIC,		/* EBCDIC */
	    TYPE_IMAGE,			/* image */
	    TYPE_LOCALB,		/* local byte size */
	    TYPE_AUTO,			/* Client side only */
	    TYPE_INVALID
    };

    enum FormE
    {
	    FORM_NONPRINT,		/* non-print */
	    FORM_TELNET,		/* telnet format effectors */
	    FORM_CRCNT,			/* carriage control (ASA) */
	    FORM_INVALID,
    };

    enum StruE
    {
	    STRU_FILE,			/* file (no record structure) */
	    STRU_RECORD,		/* record structure */
	    STRU_PAGE,	        /* page structure */
	    STRU_INVALID
    };

    enum ModeE
    {
	    MODE_STREAM,		/* stream */
	    MODE_BLOCK,			/* block */
	    MODE_CCOMPRESSED,	/* compressed */
	    MODE_INVALID
    };

    enum TransferOperationE
    {
        TROP_NORMAL,
        TROP_RESUME,
        TROP_APPEND,
        TROP_UNIQUE
    };

    enum ConnectionTypeE
    {
        CONN_ACTIVE, // PORT
        CONN_PASSIVE, // PASV
        CONN_UNKNOWN
    };

protected:
private:
};


/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SVR_PROTOCOL_FTP_ENUMS_H_ */

