/** 
*/

#ifndef WAR_SVR_PROTOCOL_FTP_MODE_H
#define WAR_SVR_PROTOCOL_FTP_MODE_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SVR_PROTOCOL_FTP_ENUMS_H
#   include "WarSvrProtocolFtpEnums.h"
#endif

#ifndef WAR_NET_ADDRESS_H
#   include "WarNetAddress.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarSvrProtocolFtpMode : 
    public WarSvrProtocolFtpEnums
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarSvrProtocolFtpMode(void)
    {
        Reset();
    }
    
    /**
    * Copy constructor.
    *
    * @param from The value to copy to this object.
    */
    WarSvrProtocolFtpMode(const WarSvrProtocolFtpMode& from)
    {
        Reset();
        operator = (from);
    }
    
    /**
    * Destructor.
    */
    ~WarSvrProtocolFtpMode(void) {}
    
    // OPERATORS
    
    /**
    * Assignment operator.
    *
    * @param from THe value to assign to this object.
    *
    * @return A reference to this object.
    */
    WarSvrProtocolFtpMode& operator = (const WarSvrProtocolFtpMode& from)
    {
        mType = from.mType;
        mForm = from.mForm;
        mStru = from.mStru;
        mMode = from.mMode;
        mTransferOperation = from.mTransferOperation;
        mConnectionType = from.mConnectionType;
        mPortAddress = from.mPortAddress;
    }
    
    // OPERATIONS    
    
    void Reset()
    {
        mType = TYPE_ASCII;
        mForm = FORM_NONPRINT;
        mStru = STRU_FILE;
        mMode = MODE_STREAM;
        mTransferOperation = TROP_NORMAL;
        mConnectionType = CONN_ACTIVE; // 
        mPortAddress.Reset();
        mRestartPos = 0;
    }

    // ACCESS
    // INQUIRY

    std::string Explain() const;

    war_ccstr_t GetTypeName() const;
    war_ccstr_t GetModeName() const;
    war_ccstr_t GetStructureName() const;
    war_ccstr_t GetFormName() const;
    
    TypeE mType;
    FormE mForm;
    StruE mStru;
    ModeE mMode;
    TransferOperationE mTransferOperation;
    ConnectionTypeE mConnectionType;
    WarNetAddress mPortAddress; // Address provided by PORT command
    WarNetAddress mLocalAddress; // The address the client connected to (server address)
    war_flen_t mRestartPos;

protected:
private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SVR_PROTOCOL_FTP_MODE_H_ */

