/** 
*/

#ifndef WAR_THREAD_ENGINE_H
#define WAR_THREAD_ENGINE_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_THREAD_H
#   include "WarThread.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarThreadEngine 
{
public:
    typedef std::set<war_thread_ptr_t> thread_set_t;

    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarThreadEngine();
    
    /**
    * Destructor.
    */
    ~WarThreadEngine();
    
    // OPERATORS    
    // OPERATIONS

    void SetPriOnAllThreads(const WarPrioritiesDefE newPriority);

    // CALLBACK
    // ACCESS

    static WarThreadEngine& GetEngine()
    {
        if (NULL == mspThis)
            WarThrow(WarError(WAR_ERR_INTERNAL_DATA_NOT_INITIALIZED), NULL);
        return *mspThis;
    }

    // INQUIRY
    
protected:
    friend class WarThread;
    void AddThread(WarThread *pThread);
    void RemoveThread(WarThread *pThread);

private:
    thread_set_t mThreads;
    WarCriticalSection mLock;
    static WarThreadEngine *mspThis;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_THREAD_ENGINE_H_ */

