/** 
*/

#ifndef WAR_USER_AUTHDATA_WIN32_NT_H
#define WAR_USER_AUTHDATA_WIN32_NT_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_USER_AUTH_DATA_H
#   include "WarUserAuthData.h"
#endif

#ifndef WAR_WIN32_REGISTRY_H
#   include "WarWin32Registry.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarUserAuthWin32Nt;
class WarSvrProperties;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarUserAuthDataWin32Nt : 
public WarUserAuthData
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarUserAuthDataWin32Nt(void) 
        : mLogonHandle(NULL),
        mIsAnonymous(false),
        mImpersonateCnt(0)
    {}
     
    /**
    * Destructor.
    */
    ~WarUserAuthDataWin32Nt(void)
    {
#if WAR_CATCH_ALL
        try
#endif
        {
            if (mLogonHandle)
                ::CloseHandle(mLogonHandle);
        }

#if WAR_CATCH_ALL        
        catch(...)
        {
            ; // Nothing
        }
#endif
    }
    
    // OPERATORS    
    // OPERATIONS 
    
    virtual void BeginImpersonate() 
        throw(WarException);
    
    virtual void EndImpersonate()
        throw(WarException);;
    
    // ACCESS
    // INQUIRY

    virtual bool IsAnonymous() const
    {
        return mIsAnonymous;
    }

    /* Merge the current effective properties, so that the
     * properties specified for the user takes precidence.
     */
    virtual void 
    MergeProperties(WarSvrProperties& effectiveProperties)
        throw(WarException);

    const WarWin32Registry& GetRegRoot() const
    {
        return mRegRoot;
    }

protected:
    friend WarUserAuthWin32Nt;
    bool mIsAnonymous;

    void LoadOptions(const WarOptionList& inheritOptions);

private:
    friend WarUserAuthWin32Nt;
    HANDLE mLogonHandle;
    int mImpersonateCnt;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_USER_AUTHDATA_WIN32_NT_H_ */

