/** 

    This is the a handler of the chained WarUserAuth
    objects. WarUserAuth ovjects are installed here,
    and WarUserHandle instances are obtained from here.

*/

#ifndef WAR_USER_ENGINE_H
#define WAR_USER_ENGINE_H

/* SYSTEM INCLUDES */

#ifndef WAR_LIST_INCLUDED
#   define WAR_LIST_INCLUDED
#   include <list>
#endif

/* PROJECT INCLUDES */

#ifndef WAR_USER_AUTH_H
#   include "WarUserAuth.h"
#endif

#ifndef WAR_SERVER_ENUMS_H
#   include "WarSvrEnums.h"
#endif

#ifndef WAR_SMART_POINTER_H
#   include "WarSmartPointer.h"
#endif

#ifndef WAR_PTR_WRAPPER_H
#   include "WarPtrWrapper.h"
#endif

#ifndef WAR_SVR_PATH_H
#   include "WarSvrPath.h"
#endif


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarUserEngine : public WarSvrEnums
{
public:
    typedef WarPtrWrapper<WarUserAuth> auth_ptr_t;
    typedef std::list<auth_ptr_t> auth_list_t;
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarUserEngine(void);
     
    /**
    * Destructor.
    */
    ~WarUserEngine(void);
    
    // OPERATORS
     
    void AddAuthModule(auth_ptr_t& authModule)
        throw(WarException);

    /** Server login. 
      *
      * @return Login result code. If the login 
      * succeeds, the authModule argument returns 
      * the auth-module that has authenticated the user.
      *
      * @exception WarException on error. 
      */
    WarLoginResultE Login(
        WarSvrProtocol& fromServer,
        war_ccstr_t virtualHost, 
        war_ccstr_t userName, 
        war_ccstr_t userPasswd,
        auth_ptr_t& authModule, // Auth module
        war_authdata_ptr_t& authDataPtr) // Session data
        throw(WarException);

    // OPERATIONS                       
    // ACCESS

    const auth_list_t& GetAuthModules() const
    {
        return mAuthModules;
    }

    // INQUIRY

protected:

private:
    auth_list_t mAuthModules;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarUserEngine::auth_ptr_t war_auth_ptr_t;

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_USER_ENGINE_H_ */

