

#ifndef WAR_WIN32_NT_SERVICE_MSGS_H
#define WAR_WIN32_NT_SERVICE_MSGS_H


//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//


//
// MessageId: WAR_EVMSG_INSTALLED
//
// MessageText:
//
//  The %1 service was installed.
//
#define WAR_EVMSG_INSTALLED                  0x00000064L

//
// MessageId: WAR_EVMSG_REMOVED
//
// MessageText:
//
//  The %1 service was removed.
//
#define WAR_EVMSG_REMOVED                    0x00000065L

//
// MessageId: WAR_EVMSG_NOTREMOVED
//
// MessageText:
//
//  The %1 service could not be removed.
//
#define WAR_EVMSG_NOTREMOVED                 0x00000066L

//
// MessageId: WAR_EVMSG_CTRLHANDLERNOTINSTALLED
//
// MessageText:
//
//  The control handler could not be installed.
//
#define WAR_EVMSG_CTRLHANDLERNOTINSTALLED    0x00000067L

//
// MessageId: WAR_EVMSG_FAILEDINIT
//
// MessageText:
//
//  The initialization process failed.
//
#define WAR_EVMSG_FAILEDINIT                 0x00000068L

//
// MessageId: WAR_EVMSG_STARTED
//
// MessageText:
//
//  The service was started.
//
#define WAR_EVMSG_STARTED                    0x00000069L

//
// MessageId: WAR_EVMSG_BADREQUEST
//
// MessageText:
//
//  The service received an unsupported request.
//
#define WAR_EVMSG_BADREQUEST                 0x0000006AL

//
// MessageId: WAR_EVMSG_DEBUG
//
// MessageText:
//
//  Debug: %1
//
#define WAR_EVMSG_DEBUG                      0x0000006BL

//
// MessageId: WAR_EVMSG_STOPPED
//
// MessageText:
//
//  The service was stopped.
//
#define WAR_EVMSG_STOPPED                    0x0000006CL

#endif WAR_WIN32_NT_SERVICE_MSGS_H

