/* getopt.h
 * 
 * Reimplemented in relatively portable code, so that Win32
 * and other platforms can share the joy.
 * 
 * Copyright 2000 Jarle (jgaa) Aase
 * Released under Jgaa's Public License (JPL)
 *
 * Homepage: http://clib.jgaa.com
 * Authors homepage: http://www.jgaa.com
 * Bug-reports: http://support.jgaa.com
 */


#ifndef GETOPT_H_INCLUDED
#define GETOPT_H_INCLUDED

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

    /* ---------------- START OF C HEADER -------------- */

    int getopt_long(int argc,
                    char * const argv[],
                    const char *optstring,
                    const struct option *longopts,
                    int *longindex);

    struct option
    {
        const char *name;
        int has_arg;
        int *flag;
        int val;
    };

    enum {no_argument, required_argument, optional_argument};

    extern const char *optarg;
    extern int optind, opterr, optopt;

    /* ---------------- END OF C HEADER -------------- */
#ifdef __cplusplus
}
#endif /* __cplusplus */

#ifndef WAR_GETOPT_CLASS
#   endif /* GETOPT_H_INCLUDED */
#endif

