
#include "StdAfx.h"
#include "WarServerSnapin.h"
#include "WarSvrSnapin.h"

#include "WarMmcNodeFileShare.h"
#include "PropPageFileShareName.h"

PropPageFileShareName::PropPageFileShareName(warmmc_file_share_data_ptr_t& dataPtr,
                                           long lNotifyHandle, 
                                           bool bDeleteHandle, 
                                           TCHAR* pTitle) 
                                           : 
CSnapInPropertyPageImpl<PropPageFileShareName> (pTitle),
m_lNotifyHandle(lNotifyHandle),
m_bDeleteHandle(bDeleteHandle), // Should be true for only page.
mDataPtr(dataPtr)
{
}

PropPageFileShareName::~PropPageFileShareName()
{
    if (m_bDeleteHandle)
        MMCFreeNotifyHandle(m_lNotifyHandle);
}


BOOL PropPageFileShareName::OnSetActive()
{
    ValidateName();
    return TRUE;
}

LRESULT PropPageFileShareName::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
    SetDlgItemText(IDC_NAME, _T("/new"));
    ValidateName();
    return TRUE;
}


BOOL PropPageFileShareName::OnApply()
{
    if (!ValidateName())
        return false;

    mDataPtr->Apply(m_lNotifyHandle, 1);

    return true;
}

BOOL PropPageFileShareName::ValidateName()
{
    DWORD flags = 0;
    BOOL rval = TRUE;
    
    TCHAR buffer[MAX_PATH];
    GetDlgItemText(IDC_NAME, buffer, sizeof(buffer));

    mDataPtr->SetName(war_regstr_t(buffer));

    if (rval = mDataPtr->HaveValidName()) // OK
        flags |= PSWIZB_NEXT;
    
    mDataPtr->AddMask(1);
    
    ::PostMessage(GetParent(), PSM_SETWIZBUTTONS, 0, flags);

    return rval;
}

LRESULT PropPageFileShareName::OnChangeName(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
    ValidateName();
    return 0;
}

