#ifndef WAR_PROP_PAGE_FILE_SHARE_NAME_H
#define WAR_PROP_PAGE_FILE_SHARE_NAME_H

#include "resource.h"
#include <atlsnap.h>

#ifndef WAR_WIN32_REGISTRY_H
#   include "WarWin32Registry.h"
#endif

#ifndef WAR_MMC_FILE_NODE_DATA_H
#   include "WarMmcFileNodeData.h"
#endif

class WarMmcNodeFileShare;

class PropPageFileShareName : public CSnapInPropertyPageImpl<PropPageFileShareName>
{
public :
	PropPageFileShareName(
        warmmc_file_share_data_ptr_t& dataPtr, 
        long lNotifyHandle, 
        bool bDeleteHandle = false, 
        TCHAR* pTitle = NULL);

	~PropPageFileShareName();
	
	enum { IDD = IDD_FILE_NEWNAME };

BEGIN_MSG_MAP(PropPageFileShareName)
    MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	CHAIN_MSG_MAP(CSnapInPropertyPageImpl<PropPageFileShareName>)
	COMMAND_HANDLER(IDC_NAME, EN_CHANGE, OnChangeName)
END_MSG_MAP()

    LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    BOOL OnApply();
    BOOL OnSetActive();

    BOOL ValidateName();

public:
	long m_lNotifyHandle;
	bool m_bDeleteHandle;

private:
    warmmc_file_share_data_ptr_t mDataPtr;

    void UpdateUrlItem();

	LRESULT OnChangeName(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
};

#endif // WAR_PROP_PAGE_FILE_SHARE_NAME_H

