#ifndef WAR_PROP_PAGE_FILE_SHARE_PERMISSIONS_H
#define WAR_PROP_PAGE_FILE_SHARE_PERMISSIONS_H

#include "resource.h"
#include <atlsnap.h>

#ifndef WAR_WIN32_REGISTRY_H
#   include "WarWin32Registry.h"
#endif

#ifndef WAR_MMC_FILE_NODE_DATA_H
#   include "WarMmcFileNodeData.h"
#endif

class PropPageFileShareUrl;

class PropPageFileSharePermissions 
: public CSnapInPropertyPageImpl<PropPageFileSharePermissions>,
public WarSvrEnums
{
public :
	PropPageFileSharePermissions(
        warmmc_file_share_data_ptr_t dataPtr, 
        long lNotifyHandle, 
        bool bDeleteHandle = false, 
        TCHAR* pTitle = NULL);
	~PropPageFileSharePermissions();

	enum { IDD = IDD_FILE_PERMISSIONS_DLG };

    BEGIN_MSG_MAP(PropPageFileSharePermissions)
        MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
        COMMAND_HANDLER(IDC_DENY, BN_CLICKED, OnClickedDeny)
        COMMAND_HANDLER(IDC_SYMLINKS, CBN_SELCHANGE, OnSelchangeSymlinks)
        COMMAND_HANDLER(IDC_APPEND, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_CREATE, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_CWD, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_DELETE, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_EXECUTE, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_FREE, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_HIDE, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_LIST, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_MAP_SYMLINKS, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_MK_SYMLINK, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_READ, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_RECURSIVE, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_REMOVE, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_SHARED_UPLOAD, BN_CLICKED, OnClicked)
        COMMAND_HANDLER(IDC_STYLE, CBN_SELCHANGE, OnSelchangeStyle)
        COMMAND_HANDLER(IDC_WRITE, BN_CLICKED, OnClicked)
        CHAIN_MSG_MAP(CSnapInPropertyPageImpl<PropPageFileSharePermissions>)
    END_MSG_MAP()
        
        
    LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    BOOL OnApply();
    BOOL OnSetActive();
    BOOL OnWizardFinish();

public:
	long m_lNotifyHandle;
	bool m_bDeleteHandle;


private:
    warmmc_file_share_data_ptr_t mDataPtr;

    void UpdatePermsOnScreen(bool doFullUpdate = false);
    void ReloadStyles(bool doFullUpdte);
    
    void UpdatePermsFromScreen();
	
    LRESULT OnClickedDeny(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnSelchangeSymlinks(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

	LRESULT OnClicked(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnSelchangeStyle(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

};

#endif // WAR_PROP_PAGE_FILE_SHARE_PERMISSIONS_H

