#ifndef WAR_PROP_PAGE_FILE_SHARE_URL_H
#define WAR_PROP_PAGE_FILE_SHARE_URL_H

#include "resource.h"
#include <atlsnap.h>

#ifndef WAR_WIN32_REGISTRY_H
#   include "WarWin32Registry.h"
#endif

#ifndef WAR_MMC_FILE_NODE_DATA_H
#   include "WarMmcFileNodeData.h"
#endif

class WarMmcNodeFileShare;

class PropPageFileShareUrl : public CSnapInPropertyPageImpl<PropPageFileShareUrl>
{
public :
	PropPageFileShareUrl(
        warmmc_file_share_data_ptr_t& dataPtr, 
        long lNotifyHandle, 
        bool bDeleteHandle = false, 
        TCHAR* pTitle = NULL);

	~PropPageFileShareUrl();
	
	enum { IDD = IDD_FILE_URL_DLG };

BEGIN_MSG_MAP(PropPageFileShareUrl)
    MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	CHAIN_MSG_MAP(CSnapInPropertyPageImpl<PropPageFileShareUrl>)
	COMMAND_HANDLER(IDC_BROWSE, BN_CLICKED, OnClickedBrowse)
	COMMAND_HANDLER(IDC_HOST, EN_KILLFOCUS, OnKillfocusHost)
	COMMAND_HANDLER(IDC_PASSWORD, EN_KILLFOCUS, OnKillfocusPassword)
	COMMAND_HANDLER(IDC_PATH, EN_KILLFOCUS, OnKillfocusPath)
	COMMAND_HANDLER(IDC_TYPE, CBN_KILLFOCUS, OnKillfocusType)
	COMMAND_HANDLER(IDC_USER, EN_KILLFOCUS, OnKillfocusUser)
END_MSG_MAP()

    LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    BOOL OnApply();
    BOOL OnSetActive();

    void UpdateUrl(LPCSTR str) throw(WarException);

    void RebuildUrl() throw(WarException);

public:
	long m_lNotifyHandle;
	bool m_bDeleteHandle;

private:
    warmmc_file_share_data_ptr_t mDataPtr;

    void UpdateUrlItem();

	LRESULT OnClickedBrowse(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnKillfocusHost(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnKillfocusPassword(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnKillfocusPath(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnKillfocusType(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnKillfocusUser(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
};

#endif // WAR_PROP_PAGE_FILE_SHARE_URL_H

