#ifndef WAR_PROP_PAGE_NT_AUTH_H
#define WAR_PROP_PAGE_NT_AUTH_H

#include "resource.h"
#include <atlsnap.h>
#include "WarWin32Registry.h"
#include <lm.h>

class CPropPageNtAuth : public CSnapInPropertyPageImpl<CPropPageNtAuth>
{
public :
	CPropPageNtAuth(WarWin32Registry& regKey, long lNotifyHandle, bool bDeleteHandle = false, TCHAR* pTitle = NULL);

	~CPropPageNtAuth();

	enum { IDD = IDD_NT_AUTH_DLG };

BEGIN_MSG_MAP(CPropPageNtAuth)
    MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	CHAIN_MSG_MAP(CSnapInPropertyPageImpl<CPropPageNtAuth>)
	COMMAND_HANDLER(IDC_USE_LOCAL_MACHINE, BN_CLICKED, OnClickedUse_local_machine)
	COMMAND_HANDLER(IDC_ALLOW_ANONYMOUS, BN_CLICKED, OnClickedAllow_anonymous)
	COMMAND_HANDLER(IDC_FTP_GROUP, CBN_DROPDOWN, OnDropdownFtp_group)
	COMMAND_HANDLER(IDC_RESET, BN_CLICKED, OnClickedReset)
END_MSG_MAP()

	HRESULT PropertyChangeNotify(long param);

    LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    void UpdateEnabledFileds();

    BOOL OnApply();

public:
	long m_lNotifyHandle;
	bool m_bDeleteHandle;

	LRESULT OnClickedUse_local_machine(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedAllow_anonymous(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnDropdownFtp_group(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);	
    LRESULT OnClickedReset(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
private:
    WarWin32Registry& mRegKey;
};

#endif // WAR_PROP_PAGE_NT_AUTH_H

