/** 
*/

#ifndef WAR_MMC_FILE_NODE_DATA_H
#define WAR_MMC_FILE_NODE_DATA_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */
#ifndef WAR_SMART_POINTER_H
#   include "WarSmartPointer.h"
#endif

#ifndef WAR_SVR_ENUMS_H
#   include "WarSvrEnums.h"
#endif

#ifndef WAR_WIN32_REGISTRY_H
#   include "WarWin32Registry.h"
#endif

#ifndef WAR_MMC_MISSING_FEATURES_IN_LAME_FRAMEWORK_H
#   include "WarMmcMissingFeaturesInLameFramework.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarMmcFileNodeData 
: public WarSvrEnums,
public WarMmcFuckLameMicrosoftForNotImplementingThis
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarMmcFileNodeData(
        WarMmcNodeEventBase& node,
        const war_regstr_t& name,
        const WarWin32Registry& regParent, // The node above the file dta item
        bool canChangeName = false);
    
    /**
    * Destructor.
    */
    ~WarMmcFileNodeData(void);
    
    // OPERATORS
    
    /**
    * Assignment operator.
    *
    * @param from THe value to assign to this object.
    *
    * @return A reference to this object.
    */
    WarMmcFileNodeData& operator=(WarMmcFileNodeData& from);
    
    // OPERATIONS

    void SetUrl(const WarUrl& from) 
        throw(WarException)
    {
        mUrl = from;
    }

    void SetPermissions(war_uint32_t perms)
        throw(WarException)
    {
        mPerms = perms;
    }

    void SetName(const war_regstr_t& name)
        throw(WarException)
    {
        mName = name;
    }

    void Load() throw(WarException);

    void Save() throw(WarException);

    // ACCESS
    // INQUIRY

    const war_regstr_t& GetName() const
    {
        return mName;
    }

    const WarWin32Registry& GetReg() const
    {
        return mRegKey;
    }
    
    WarUrl GetUrl() const
    {
        return mUrl;
    }

    war_uint32_t GetPermissions() const
    {
        return mPerms;
    }

    // For new nodes, denies using an existing name
    bool HaveValidName() const;

protected:
private:
    WarWin32Registry mRegKey; // To the node above the file-share
    WarUrl mUrl; // URL for the share
    war_uint32_t mPerms; // Permissions
    war_regstr_t mName; // Alias, Name on the node in the registry
    bool mCanChangeName; // True when we create new nodes
};

typedef WarPtrWrapper<WarMmcFileNodeData> warmmc_file_share_data_ptr_t;

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_MMC_FILE_NODE_DATA_H_ */

