/** 
*/

#ifndef WAR_MMC_NODE_AUTH_MODULES_H
#define WAR_MMC_NODE_AUTH_MODULES_H

/* SYSTEM INCLUDES */

/* PROJECT INCLUDES */

#ifndef WAR_MMC_BASE_NODE_H
#   include "WarMmcBaseNode.h"
#endif

#include "WarMmcNodeAuthNt.h"

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarMmcNodeAuthModules 
: public WarMmcBaseNode<WarMmcNodeAuthModules> 
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarMmcNodeAuthModules(const war_registrypath_t& regNode)
    {
        mRegKey.Open(HKEY_LOCAL_MACHINE, regNode, KEY_ALL_ACCESS);
    }
    
     /**
    * Destructor.
    */
    ~WarMmcNodeAuthModules(void) {}
    
    // OPERATORS
    
    // OPERATIONS                       

    virtual HRESULT OnExpand(BOOL bExpand, IConsole *pConsole, HSCOPEITEM parent) 
	{   
        if (bExpand)
        {
            CComQIPtr<IConsoleNameSpace, 
                &IID_IConsoleNameSpace> 
                spConsoleNameSpace(pConsole);

            WarWin32Registry::keyname_list_t svr_list;
            try
            {
                mRegKey.EnumKey(svr_list);

                for(WarWin32Registry::keyname_list_t::const_iterator 
                    P = svr_list.begin()
                    ; P != svr_list.end()
                    ; P++)
                {
                    WarWin32Registry reg_node;
                    reg_node.Open(HKEY_LOCAL_MACHINE,
                        mRegKey.GetPath(P->c_str()), KEY_ALL_ACCESS);
                    if (reg_node.GetStrValue(WAR_WINNT_REG_CLASSID, _T(""))
                        == war_regstr_t(WarMmcNodeAuthNt::m_SZNODETYPE))
                    {
                        SCOPEDATAITEM sdi;
                        memset(&sdi, 0, sizeof(sdi));
                        sdi.mask = SDI_STR | SDI_PARAM | SDI_IMAGE 
                            | SDI_OPENIMAGE | SDI_PARENT;
                        sdi.displayname = MMC_CALLBACK;
                        sdi.relativeID = parent;
                        sdi.nImage = WAR_IL_WINDOWS;
                        sdi.nOpenImage = WAR_IL_WINDOWS;
                        sdi.lParam = (LPARAM)new WarMmcNodeAuthNt(
                            reg_node.GetPath(NULL));
                        HRESULT hr = spConsoleNameSpace->InsertItem(&sdi);
                        if (FAILED(hr))
                            return hr;
                    }
                }
            }
            catch(WarException)
            {
                return S_FALSE;
            }
            
        }
        return S_OK;
    }


    // ACCESS
    // INQUIRY
    
protected:
private:
    WarWin32Registry mRegKey;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_MMC_NODE_AUTH_MODULES_H_ */

