#include "stdafx.h"
#include <assert.h>

#include <iostream>

#include "WarPath.h"
#include "WarUtf8.h"

using namespace std;

void TestUtf8()
{
    const char *teststr = "test   ";
    wstring wide_str;
    string narrow_str;
    WarPath<wchar_t> wide_path(teststr);
    WarPath<char> narrow_path;

    wide_str = wide_path.GetPath();
    narrow_str = WarUtf8(wide_str.c_str());

    if (!WarUtf8::IsUtf8(narrow_str))
        cout << "IsUtf8(utf8_encoded_string) FAILED!" << endl;

    if (WarUtf8::IsUtf8(teststr))
        cout << "IsUtf8(non_encoded_string) FAILED!" << endl;

    wide_str.erase();
    wide_str = WarUtf8(narrow_str.c_str());
    wide_path.Reset();
    wide_path << wide_str;
    narrow_path << wide_path.GetPath();

    if (strcmp(narrow_path.GetPath(), teststr) == 0)
        cout << "UTF8 conversions succeeded" << endl;
    else
        cout << "UTF8 conversions FAILED!" << endl;
}
