
#include "stdafx.h"
#include "WarThread.h"

#include <iostream>

#include "WarLog.h"
#include "WarLogIOStreamHandler.h"

using namespace std;

class TestWarThreadClass : public WarThread
{
public:
    TestWarThreadClass(WarObjectGroup *pGroup)
        : WarThread(pGroup)
    {}

protected:
    void Run()
    {
        WarLog info_log(WARLOG_INFO, "TestWarThreadClass::Run()");

        info_log << "New thread is running." << war_endl;
        info_log << GetThreadInfo() << war_endl;
        WarTime::Sleep(2000);
        info_log << "New thread is done." << war_endl;
    }
};

void TestWarThread()
{
#define NUM_TESTS 10

    cout << "Testing WarThread" << endl;

    WarLogEngine log_engine;
    log_engine.InstallHandler(new WarLogIoStreamHandler(cout, "cout"));
   
    log_engine.EnableEvent("cout", WARLOG_THREADS);

    TestWarThreadClass *p[NUM_TESTS];
    WarObjectGroup my_threads;

    for(int i = 0; i < NUM_TESTS; i++)
    {
        p[i] = new TestWarThreadClass(&my_threads);
        p[i]->Open();
    }

    while(!my_threads.IsEmpty())
        WarTime::Sleep(500);
}

