
#include "StdAfx.h"
#include "WarftpdLite.h"

#include "WarThread.h"
#include "WarLog.h"
#include "WarLogIOStreamHandler.h"
#include "WarSvrEngine.h"
#include "WarSvrDefinitionFtp.h"
#include "WarSvrProtocolFtp.h"
#include "WarSocketEngine.h"
#include "WarSvrWin32NtEngine.h"
#include "WarFileEngine.h"
#include "WarFileDriverWin32.h"
#include "WarUserAuthWin32Nt.h"
#include "WarOs.h"
#include "WarUtf8.h"
#include "WarWin32Registry.h" 
#include "WarWin32NtService.h"
#include "WarTimer.h"
#include "WarShutdownEngine.h"
#include "WarPerfmonDef.h"
#include "WarSessionManager.h"
#include "WarPluginEngine.h"
#include "WarSocketCpsLimit.h"
#include "WarThreadEngine.h"

class WarPreMainInit
{
public:
    WarPreMainInit()
    {
        // Initialize core modules in the library
        // before we create objects that depend on
        // them
        ::CoInitialize(NULL);
        WarSmartPointer::Initialize();
    }

    ~WarPreMainInit()
    {
        ::CoUninitialize();
    }
};

class WarPreMainTimerInit
{
public:
    WarPreMainTimerInit()
    {
        mGlobalTimerObjectPtr = new WarTimer;
        mGlobalTimerObjectPtr->Open();
    }

    war_timer_ptr_t mGlobalTimerObjectPtr;
};

WarOs WarOsObject;
WarPreMainInit PreMainInit;
WarPluginEngine PluginEngineObject;
WarThreadEngine ThreadEngineObject;
WarShutdownEngine ShutdownEngineObject;
WarLogEngine LogEngine;
std::ofstream LogFile;
WarPreMainTimerInit TimerObject;
WarSessionManager SessionManagerObject;
WarFileEngine FileEngineObject;
WarSocketEngine SocketEngineObject;
WarSvrEngine ServerEngineObject;
WarSocketCpsLimit CpsLimitObject;
WarSvrWin32NtEngine win32nt_engine;

WarCollector<TCHAR> UserPasswd(WarCollector<TCHAR>::SM_ERASE),
    UserName;
