
#include "stdafx.h"
#include "WarFtpdlite.h"
#include "WarOptionList.h"


#ifdef WIN32

void WarInstallServerOptionsWin32(const WarWin32Registry& key)
{
    WarWin32Registry module_key, options_key, optval_key;

    module_key.Create(key.GetRef(WAR_WINNT_REG_MODULES));
    
    options_key.Create(module_key.GetRef(WAR_WINNT_REG_OPTIONS));

    optval_key.Create(key.GetRef(WAR_WINNT_REG_OPTIONS));

    for(const WarOptionList::options_def_t *p 
        = WarOptionList::spStandardOptions
        ; p->mName != NULL
        ; p++)
    { 
        WarWin32Registry my_key;
        war_registrypath_t my_path;
        my_path << options_key.GetRef().GetPath().GetPath() << WAR_SYSSLASH
            << p->mName;

        my_key.Create(WarWin32Registry::open_t(key, my_path));

#define VAL(a) WarCollector<TCHAR>(p->a).GetValue().c_str()
        // Declare the variable in the registry, so that user
        // interface modules can use it
        my_key.SetValue(WAR_WINNT_REG_DEF_VALUE, VAL(mDefaultValue));
        my_key.SetValue(WAR_WINNT_REG_DESCRIPTION, VAL(mDescription));
        my_key.SetValue(WAR_WINNT_REG_TYPE, p->mType);
        my_key.SetValue(WAR_WINNT_REG_LEVEL, p->mLevel);
#undef VAL
    }
}


#endif
