#include "StdAfx.h"
#include "WarFtpdLiteWin32NtService.h"   // class implemented
#include "WarftpdLite.h"
#include "WarShutdownEngine.h"
#include "WarSvrEngine.h"

/////////////////////////////// PUBLIC ///////////////////////////////////////

//============================= LIFECYCLE ====================================

WarFtpdLiteWin32NtService::WarFtpdLiteWin32NtService(const TCHAR* szServiceName)
: WarWin32NtService(szServiceName)
{
}

//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================

void WarFtpdLiteWin32NtService::Run()
{
    try
    {
        WarLog sys_log(WARLOG_SYSTEM, "WarFtpdLiteWin32NtService::Run()");

        sys_log << "---- Starting processing as native systems service ---" 
            << war_endl;

        StartServer();

        sys_log << "--- Ending processing as native systems service ---" 
            << war_endl;
        
    }
    catch(...)
    {
        ;
    }
}

void WarFtpdLiteWin32NtService::OnPause()
{
    WarSvrEngine::GetEngine().Pause();
    SetStatus(SERVICE_PAUSED);
}

void WarFtpdLiteWin32NtService::OnContinue()
{
    WarSvrEngine::GetEngine().Resume();
    SetStatus(SERVICE_RUNNING);
}

void WarFtpdLiteWin32NtService::OnStop()
{
    WarShutdownEngine::GetEngine().StartShutdown();
}

void WarFtpdLiteWin32NtService::OnShutdown()
{
    WarShutdownEngine::GetEngine().StartShutdown();
}


/////////////////////////////// PROTECTED  ///////////////////////////////////

/////////////////////////////// PRIVATE    ///////////////////////////////////

